{=======================================================================================================================

  Comming BASE

     . DBComboBox.

========================================================================================================================

  :

  11.05.2013 [-]  cbFieldChange.
             [*]     .
             [*] .
  06.02.2005 [+]       (TADODataSet).
             [*]  (Anchors):   .
             [*] .
  11.10.2002 [-] .
  27.09.2002 [*]  ().
  26.08.2002 [+]   Enabled.
             [+]    .
  15.12.2001 [+]   ReadOnly.
  01.12.2001 [*]    Comming.
             [*]    .
  23.11.2001 [-]  TAB.
  08.06.2001 [+]  .
  06.04.1999 [!]   BASE.

========================================================================================================================
  Copyright 19992013 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: BASEsfDBComboBox.pas,v 1.5 2013/08/14 05:51:44 tsk Exp $
=======================================================================================================================}
unit BASEsfDBComboBox;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls, DB, ADODB,
      // Comming;
      CommingDBComboBox, CommingFlat;

type
  TBASEDBComboBoxSF = class(TFrame)
    laDisplayLable: TcoLabel;
    cbField: TcoDBComboBox;
//    procedure cbFieldChange(Sender: TObject);
  private   { Private declarations }
    FReadOnly: Boolean;
    FEnabled: Boolean;
    procedure   SetReadOnly( const Value: Boolean );
    procedure   SetEnabledX( const Value: Boolean );
  public    { Public declarations }
    property    Enabled: Boolean read FEnabled write SetEnabledX;
    property    ReadOnly: Boolean read FReadOnly write SetReadOnly;
    procedure   FillValues( Source: TADODataSet );
  end;

implementation

{$R *.DFM}

//======================================================================================================================
{ TBASEDBComboBoxSF }
//======================================================================================================================
procedure TBASEDBComboBoxSF.SetEnabledX( const Value: Boolean );
begin
  FEnabled := Value;
  laDisplayLable.Enabled  := Value;
  cbField.ReadOnly        := not Value;
end;
//======================================================================================================================
procedure TBASEDBComboBoxSF.SetReadOnly( const Value: Boolean );
begin
  FReadOnly         := Value;
  cbField.ReadOnly  := Value;
  cbField.Enabled   := not Value;
end;
//======================================================================================================================
{procedure TBASEDBComboBoxSF.cbFieldChange( Sender: TObject );
begin
  if ( cbField.Field.Value <> cbField.Values[ cbField.ItemIndex ] ) then begin
    if not ( cbField.DataSource.State in [ dsEdit, dsInsert ]) then cbField.DataSource.Edit;
    cbField.Field.Value := cbField.Values[ cbField.ItemIndex ];
  end;
end;}
//======================================================================================================================
procedure TBASEDBComboBoxSF.FillValues( Source: TADODataSet );
begin
  with Source do begin
    Open;
    if RecordCount > 0 then begin
      First;
      cbField.Items.Clear;
      cbField.Values.Clear;
      while not Eof do begin
        cbField.Items.Add( Fields[0].Value );
        if FieldList.Count > 1
          then cbField.Values.Add( Fields[1].Value )
          else cbField.Values.Add( Fields[0].Value );
        Next;
      end;
    end;
    Close;
  end;
end;
//======================================================================================================================
end.
