{===================================================================================================

  Comming BASE

     . DBDateEdit,   .

====================================================================================================

  :

  20.04.2004 TSK  [*]  uses (Icarus).
  12.09.2002 TSK  [+]  ().
  24.05.2002 TSK  [+] Enabled:  .
  15.03.2002 TSK  [+] ReadOnly:  .
  06.12.2001 King [+]  .
  06.04.1999 TSK  [!]   BASE.

====================================================================================================
  Copyright 19992004 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  Copyright 2001 Korolev & Son Ltd., Moscow, Russia.                        Alexey Korolev
                                                                              e-mail: malta@mail.ru
  CVS: $Id: BASEsfDBDateEdit.pas,v 1.4 2004/10/19 04:49:23 tsk Exp $
===================================================================================================}
unit BASEsfDBDateEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
      Mask, DBCtrls,
      // Comming:
      CommingFlat, CommingDBEditExtended, CommingEditExtended;

type
  TBASEDBEditDateSF = class( TFrame )
    laField: TcoLabel;
    edDate: TcoDBDateEdit;
  private   { Private declarations }
    FReadOnly:  Boolean;
    FEnabled:   Boolean;
    procedure   SetReadOnly(const Value: Boolean);
    procedure   SetEnabledX(const Value: Boolean);
  public    { Public declarations }
    property    ReadOnly: Boolean read FReadOnly write SetReadOnly;
    property    Enabled: Boolean read FEnabled write SetEnabledX;
  end;

implementation

{$R *.DFM}
//==================================================================================================
{ TBASEDBEditDateSF }
//==================================================================================================
procedure TBASEDBEditDateSF.SetEnabledX(const Value: Boolean);
begin
  FEnabled        := Value;
  laField.Enabled := Value;
  edDate.ReadOnly := not Value;
end;
//==================================================================================================
procedure TBASEDBEditDateSF.SetReadOnly(const Value: Boolean);
begin
  FReadOnly       := Value;
  edDate.ReadOnly := Value;
end;
//==================================================================================================
end.
