{===================================================================================================

  Comming BASE

     .   (), ,   .

====================================================================================================

  :

  29.07.2008 TSK  [+]  .
  06.04.1999 TSK  [!]   BASE.

====================================================================================================
  Copyright 19982008 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: BASEsfEditMemoDBEdit.pas,v 1.1 2008/07/29 04:51:54 tsk Exp $
===================================================================================================}
unit BASEsfEditMemoDBEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
      Buttons, ExtCtrls, StdCtrls, Mask, DBCtrls, DB, ADODB,
      CommingFlat, CommingButton;

type
  TBASEEditMemoDBEditSF = class( TFrame )
    btLabel: TcoButton;
    edFieldID: TcoDBEdit;
    meFieldText: TcoMemo;
    edFind: TcoEdit;
  private   { Private declarations }
    FReadOnly: Boolean;
    procedure   SetReadOnly( const Value: Boolean );
    procedure   SetEnabledX(const Value: Boolean);
    function    GetEnabledX: Boolean;
  public    { Public declarations }
    property    Enabled: Boolean read GetEnabledX write SetEnabledX;
    property    ReadOnly: Boolean read FReadOnly write SetReadOnly;
  end;

implementation

{$R *.DFM}
//==================================================================================================
{ TBASEDBEditMemoSF }
//==================================================================================================
procedure TBASEEditMemoDBEditSF.SetReadOnly(const Value: Boolean);
begin
  FReadOnly           := Value;
  edFieldID.ReadOnly  := Value;
  edFind.ReadOnly     := Value;
  btLabel.NoClick     := Value;
end;
//==================================================================================================
function TBASEEditMemoDBEditSF.GetEnabledX: Boolean;
begin
  Result := inherited Enabled;
end;
//==================================================================================================
procedure TBASEEditMemoDBEditSF.SetEnabledX( const Value: Boolean );
begin
  inherited Enabled   := Value;
  btLabel.Enabled     := Value;
  edFieldID.Enabled   := Value;
  edFieldID.ReadOnly  := not Value;
  edFind.Enabled      := Value;
  edFind.ReadOnly     := not Value;
  meFieldText.Enabled := Value;
  btLabel.NoClick     := not Value;
end;
//==================================================================================================
end.
