{===================================================================================================

  Comming BASE

    . .

====================================================================================================

  :

  21.10.2008 [+]   .
  11.10.2008 [+]   "".
  04.12.2006 [+] : , , .
  14.04.2006 [+]  constructor.
             [+]     .
  12.04.2006 [*]  .
  27.11.2003 [+]  .  .
  06.04.1999 [!]   BASE.

====================================================================================================
  Copyright 19992008 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: BASEfrTableEdit.pas,v 1.9 2008/10/30 05:05:13 tsk Exp $
===================================================================================================}
unit BASEfrTableEdit;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls,
      StdCtrls, Grids, DBGridEh, DB, ADODB, ActnList,
      // BASE:
      BASEfrRoot,
      // Comming
      CommingButton, CommingDBGridEh;

type
  TOnClose = procedure of object;

  TBASETableEditFR = class(TBASERootFR)
    laTitle: TStaticText;
    grData: TcoDBGridEh;
    taData: TADODataSet;
    dsData: TDataSource;
    btInsert: TcoButton;
    alData: TActionList;
    acInsert: TAction;
    acEdit: TAction;
    acDelete: TAction;
    btEdit: TcoButton;
    btDelete: TcoButton;
    procedure btCancelClick(Sender: TObject);
    procedure acEditUpdate(Sender: TObject);
    procedure acInsertUpdate(Sender: TObject);
    procedure FrameResize(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
    OnClose: TOnClose;
    constructor CreateComming( AOwner: TComponent; AProc: TOnClose );
  end;

implementation

uses BASEdmData;

{$R *.dfm}
//==================================================================================================
{ TBASETableEditFR }
//==================================================================================================
constructor TBASETableEditFR.CreateComming(AOwner: TComponent; AProc: TOnClose);
begin
  inherited Create(AOwner);
  OnClose := AProc;
end;
//==================================================================================================
procedure TBASETableEditFR.btCancelClick(Sender: TObject);
begin
  taData.Cancel;
  taData.Close;
  if Assigned( OnClose ) then OnClose;
  inherited;
end;
//==================================================================================================
procedure TBASETableEditFR.acInsertUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taData.Active );
end;
//==================================================================================================
procedure TBASETableEditFR.acEditUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taData.Active ) and ( taData.RecNo > 0 );
end;
//==================================================================================================
procedure TBASETableEditFR.FrameResize(Sender: TObject);
  var d: Integer;
begin
  inherited;
  d := grData.EmptyRow;
  if d > 0 then begin
    Top     := Top + d;
    Height  := Height - d;
  end;
end;
//==================================================================================================
end.
