/*=====================================================================================================================

   "Videoteq.XE".

    , .

=======================================================================================================================

  :

  30.03.2015 [+] ReportEmtyUnit:  .
             [+]  .
  17.12.2004 [!]  .

=======================================================================================================================
  Copyright 20042015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scReport.sql,v 1.1 2015/03/30 10:32:28 tsk Exp $
=====================================================================================================================*/
USE Videoteq
--
EXECUTE CheckDropView 'ReportEmtyUnit'
--
GO
--=====================================================================================================================
CREATE VIEW ReportEmtyUnit
AS
  SELECT Film.TitleYearCountry AS FilmName, 
         Medium.Number AS StorName, 
         Unit.Display AS UnitName, 
         Film.[Range]
    FROM Unit
      INNER JOIN Film ON Unit.Film = Film.ID
      INNER JOIN MediumUnit ON Unit.ID = MediumUnit.Unit 
      INNER JOIN Medium ON MediumUnit.Medium = Medium.ID
    WHERE (Unit.[Format] IS NULL)
--
GO
--=====================================================================================================================
-- 
--
SELECT * FROM ReportEmtyUnit ORDER BY [Range]