{===================================================================================================

   "Videoteq".

      , .

====================================================================================================

  :

  02.08.2007 [*] . 
             [*]  .
  27.07.2007 [+]  .
  10.10.2006 [+]  .
  17.12.2004 [!]  .

====================================================================================================
  Copyright 20042007 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: fmAttributeGroup.pas,v 1.4 2012/10/22 07:08:32 tsk Exp $
===================================================================================================}
unit fmAttributeGroup;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, PrnDbgeh,
      DB, ADODB, ActnList, TB2Item, TB2Dock, TB2Toolbar, Grids, DBGridEh, ExtCtrls, DBActns,
      StdCtrls, PropStorageEh, PropFilerEh,
      // BASE:
      BASEfmTableEdit, BASEsfDBEdit,
      // Comming:
      CommingDBGridEh, CommingADO, TB2ExtItems;

type
  TFilmAttributeGroupFM = class( TBASETableEditFM )
    frName: TBASEDBEditSF;
    frVariation: TBASEDBEditSF;
    frMany: TBASEDBEditSF;
    acMoveDown: TAction;
    spMove: TADOStoredProc;
    TBItem14: TTBItem;
    TBItem15: TTBItem;
    acMoveUp: TAction;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure taTableAfterPost(DataSet: TDataSet);
    procedure acMoveDownExecute(Sender: TObject);
    procedure acMoveUpExecute(Sender: TObject);
  private   { Private declarations }
    procedure RefreshData( Key: Variant );
  public    { Public declarations }
  end;

  procedure FilmAttributeGroup( Group: Integer = -1);

var FilmAttributeGroupFM: TFilmAttributeGroupFM;

implementation

uses BASEfmRoot, dmCommingData, dmLookupComboData;

{$R *.dfm}
//==================================================================================================
procedure FilmAttributeGroup( Group: Integer );
begin
  if FilmAttributeGroupFM = nil then begin
    Application.CreateForm( TFilmAttributeGroupFM, FilmAttributeGroupFM );
  end;
  FilmAttributeGroupFM.Show;
  if Group > 0 then FilmAttributeGroupFM.taTable.Locate( 'ID', Group, []);
end;
//==================================================================================================
{ TFilmAttributeGroupFM }
//==================================================================================================
procedure TFilmAttributeGroupFM.FormCreate(Sender: TObject);
begin
  inherited;
  DisableItemSelfRun( dmComming.acAttributeGroup );
end;
//==================================================================================================
procedure TFilmAttributeGroupFM.FormDestroy(Sender: TObject);
begin
  inherited;
  FilmAttributeGroupFM := nil;
end;
//==================================================================================================
procedure TFilmAttributeGroupFM.taTableAfterPost(DataSet: TDataSet);
begin
  inherited;
  dmCombo.taAttribute.Requery;
end;
//==================================================================================================
procedure TFilmAttributeGroupFM.RefreshData(Key: Variant);
begin
  if Key = CURRENT_RECORD then Key := taTable.FieldValues['ID'];
  taTable.Requery;
  taTable.Locate( 'ID', Key, []);
end;
//==================================================================================================
{  }
//==================================================================================================
procedure TFilmAttributeGroupFM.acMoveDownExecute(Sender: TObject);
begin
  spMove.Parameters[1].Value := taTable.FieldValues['ID'];
  spMove.Parameters[2].Value := 1;
  spMove.ExecProc;
  RefreshData( CURRENT_RECORD );
end;
//==================================================================================================
procedure TFilmAttributeGroupFM.acMoveUpExecute(Sender: TObject);
begin
  spMove.Parameters[1].Value := taTable.FieldValues['ID'];
  spMove.Parameters[2].Value := -1;
  spMove.ExecProc;
  RefreshData( CURRENT_RECORD );
end;
//==================================================================================================
end.
