{=======================================================================================================================

   "Videoteq".

     , , .

========================================================================================================================

  :

  23.10.2012 [+]     www.kinopoisk.ru.
  28.06.2008 [+]     .
  24.05.2007 [+] .
  05.12.2006 [+] , , .
  04.12.2006 [+]  .
  17.12.2004 [!]  .

========================================================================================================================
  Copyright 20042012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: frAttributeList.pas,v 1.8 2012/10/24 11:39:46 tsk Exp $
=======================================================================================================================}
unit frAttributeList;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls,
      DB, ADODB, StdCtrls, Grids, DBGridEh, ActnList,
      // BASE:
      BASEfrTableEdit,
      // Comming:
      CommingDBGridEh, CommingButton, CommingADO, CommingDB,
      // Videoteq:
      frAttributeEdit, frAttributetSearchWeb;

type
  TFilmAttributeListFR = class(TBASETableEditFR)
    taDataID: TAutoIncField;
    taDataFilmAttribute: TStringField;
    taDataGroup: TSmallintField;
    btUp: TcoButton;
    acMoveUp: TAction;
    acMoveDown: TAction;
    btDown: TcoButton;
    spMove: TADOStoredProc;
    btFilm: TcoButton;
    acFindFilm: TAction;
    taDataValueID: TAutoIncField;
    btSearch: TcoButton;
    procedure acInsertExecute(Sender: TObject);
    procedure acEditExecute(Sender: TObject);
    procedure acDeleteExecute(Sender: TObject);
    procedure acMoveUpExecute(Sender: TObject);
    procedure acMoveDownExecute(Sender: TObject);
    procedure acFindFilmExecute(Sender: TObject);
    procedure btSearchClick(Sender: TObject);
  private   { Private declarations }
    FEdit: TFilmAttributeEditFR;
    FSearch: TFilmAttributetSearchWebFR;
    FFilm: Integer;
  public    { Public declarations }
    procedure CheckRun( var AFrame: TFilmAttributeListFR; AOwner: TComponent; PAPost: TOnClose;
                        Film: Integer );
    procedure RefreshGrid( Key: Variant );
    procedure RefreshGridFull;
  end;

implementation

uses dmCommingData, fmSearch;

{$R *.dfm}
//======================================================================================================================
{ TFilmAttributeListFR }
//======================================================================================================================
procedure TFilmAttributeListFR.CheckRun( var AFrame: TFilmAttributeListFR; AOwner: TComponent;
                                         PAPost: TOnClose; Film: Integer);
begin
  Screen.Cursor := crHourGlass;
  if AFrame = nil then AFrame := TFilmAttributeListFR.CreateComming( AOwner, PAPost );
  with AFrame do begin
    FFilm := Film;
    RequeryParameters( taData, [ Film ]);
    ShowModal;
  end;
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TFilmAttributeListFR.RefreshGrid( Key: Variant );
begin
  if Key = CURRENT_RECORD then Key := taDataID.Value;
  taData.Requery;
  taData.Locate( 'ID', Key, [])
end;
//======================================================================================================================
procedure TFilmAttributeListFR.RefreshGridFull;
begin
  RefreshGrid( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TFilmAttributeListFR.acInsertExecute(Sender: TObject);
begin
  inherited;
  FEdit.CheckRun( FEdit, Owner, RefreshGrid, INSERT_DATA, FFilm);
end;
//======================================================================================================================
procedure TFilmAttributeListFR.acEditExecute(Sender: TObject);
begin
  inherited;
  FEdit.CheckRun( FEdit, Owner, RefreshGrid, taDataID.Value, FFilm, taDataGroup.Value );
end;
//======================================================================================================================
procedure TFilmAttributeListFR.acDeleteExecute(Sender: TObject);
begin
  inherited;
  DeleteRecord( 'FilmAttribute', taDataID );
  taData.Prior;
  RefreshGrid( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TFilmAttributeListFR.acMoveUpExecute(Sender: TObject);
begin
  spMove.Parameters[1].Value := taDataID.Value;
  spMove.Parameters[2].Value := 1;
  spMove.ExecProc;
  RefreshGrid( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TFilmAttributeListFR.acMoveDownExecute(Sender: TObject);
begin
  spMove.Parameters[1].Value := taDataID.Value;
  spMove.Parameters[2].Value := -1;
  spMove.ExecProc;
  RefreshGrid( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TFilmAttributeListFR.acFindFilmExecute(Sender: TObject);
begin
  SearchAttributeRun( taDataValueID.Value );
end;
//======================================================================================================================
procedure TFilmAttributeListFR.btSearchClick(Sender: TObject);
begin
  FSearch.CheckRun( FSearch, Owner, RefreshGridFull, FFilm );
end;
//======================================================================================================================
end.
