{===================================================================================================

   "Phondex"

     , .

====================================================================================================

  :

  12.09.2008 [+]    .
  02.08.2007 [*] .
             [*]  .
  10.10.2006 [+]  .
  11.04.2006 [+]  .
  17.12.2004 [!]  .

====================================================================================================
  Copyright 20042008 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: fmFilmKind.pas,v 1.3 2009/12/10 12:39:03 tsk Exp $
===================================================================================================}
unit fmFilmKind;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, PrnDbgeh,
      DB, ADODB, ActnList, TB2Item, TB2Dock, TB2Toolbar, Grids, DBGridEh, ExtCtrls, DBActns,
      StdCtrls, PropStorageEh, PropFilerEh,
      // BASE:
      BASEfmTableEdit, BASEsfDBEdit,
      // Comming:
      CommingDBGridEh, CommingADO, TB2ExtItems;

type
  TFilmKindFM = class( TBASETableEditFM )
    frName: TBASEDBEditSF;
    frCode: TBASEDBEditSF;
    acMoveDown: TAction;
    acMoveUp: TAction;
    spMove: TADOStoredProc;
    TBItem14: TTBItem;
    TBItem15: TTBItem;
    frBook: TBASEDBEditSF;
    frStep: TBASEDBEditSF;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acMoveDownExecute(Sender: TObject);
    procedure acMoveUpExecute(Sender: TObject);
  private   { Private declarations }
    procedure RefreshData( Key: Variant );
  public    { Public declarations }
  end;

  procedure FilmKindRun;

var FilmKindFM: TFilmKindFM;

implementation

uses BASEfmRoot, dmCommingData;

{$R *.dfm}
//==================================================================================================
procedure FilmKindRun;
begin
  if FilmKindFM = nil then begin
    Application.CreateForm( TFilmKindFM, FilmKindFM );
  end;
  FilmKindFM.Show;
end;
//==================================================================================================
{ TFilmKindFM }
//==================================================================================================
procedure TFilmKindFM.FormCreate(Sender: TObject);
begin
  inherited;
  DisableItemSelfRun( dmComming.acFilmKind );
end;
//==================================================================================================
procedure TFilmKindFM.FormDestroy(Sender: TObject);
begin
  inherited;
  FilmKindFM := nil;
end;
//==================================================================================================
procedure TFilmKindFM.RefreshData(Key: Variant);
begin
  if Key = CURRENT_RECORD then Key := taTable.FieldValues['Kind'];
  taTable.Requery;
  taTable.Locate( 'Kind', Key, []);
end;
//==================================================================================================
{  }
//==================================================================================================
procedure TFilmKindFM.acMoveDownExecute(Sender: TObject);
begin
  spMove.Parameters[1].Value := taTable.FieldValues['Kind'];
  spMove.Parameters[2].Value := 1;
  spMove.ExecProc;
  RefreshData( CURRENT_RECORD );
end;
//==================================================================================================
procedure TFilmKindFM.acMoveUpExecute(Sender: TObject);
begin
  spMove.Parameters[1].Value := taTable.FieldValues['Kind'];
  spMove.Parameters[2].Value := -1;
  spMove.ExecProc;
  RefreshData( CURRENT_RECORD );
end;
//==================================================================================================
end.
