{=======================================================================================================================

   "Videoteq".

     , .

========================================================================================================================

  :

  30.01.2014 [*]      c   .
  28.01.2014 [*]     .
             [+]       .
             [+]        .
             [+]       .
  24.10.2012 [*] .
  30.08.2008 [+] :  .
  29.02.2008 [+]     .
  01.09.2007 [*]      .
  29.08.2007 [*]      .
  09.08.2007 [*]   .
  08.08.2007 [+]  .
  24.07.2007 [*]   Windows Vista.
  12.01.2007 [*]       (   ) xml-.
  27.12.2006 [+]      xml-.
  26.12.2006 [+]      xml-.
  16.12.2006 [+]  ,     .
  10.10.2006 [+]  .
             [+]     .
             [*]  .
  26.04.2006 [*]    .
  16.04.2006 [-]  .
  13.10.2005 [*]    .
  23.09.2005 [+]   .
             [+]  .
  22.09.2005 [*]    .
  25.07.2005 [+]    .
  13.04.2005 [*]   .
  30.03.2005 [+]     .
  23.03.2005 [+] : , .
  21.03.2005 [*]     .
             [+] :    .
  17.03.2005 [+] : .
             [+] : .
  16.03.2005 [+] :   .
  14.03.2005 [+]  (): , .
  09.03.2005 [+] : ,  , .
             [+] : , .
             [+]   ,   .
             [+]     .
             [*]   ,     .
  31.01.2005 [+]  ,    .
  29.01.2005 [+]  .
  17.12.2004 [!]  .

========================================================================================================================
  Copyright 20042014 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: fmFilm.pas,v 1.37 2014/01/30 01:22:21 tsk Exp $
=======================================================================================================================}
unit fmFilm;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs,
      PropFilerEh, PropStorageEh, ActnList, TB2Item, TB2Dock, TB2Toolbar, ExtCtrls, DB, ADODB,
      Grids, DBGridEh, StdCtrls, Mask, DBCtrls, Menus, Clipbrd,
      // BASE:
      BASEfmRoot, BASEsfDBLookupCombo,
      // Comming:
      CommingDBGridEh, CommingADO, CommingFlat, CommingParameterTable, CommingLookupFlat,
      CommingDBImage, CommingOther, CommingSystem,
      // Videoteq:
      frFilmEdit, frFilmAddition, frAttributeList, frUnitEdit, frUnitMedium, frUnitMediaList;

type
  TFilmFM = class(TBASERootFM)
    taFilm: TADODataSet;
    dsFilm: TDataSource;
    grFilm: TcoDBGridEh;
    taKind: TADODataSet;
    taKindKind: TStringField;
    taKindName: TStringField;
    dsKind: TDataSource;
    taFilmID: TIntegerField;
    acFilmInsert: TAction;
    TBItem4: TTBItem;
    acFilmEdit: TAction;
    TBItem5: TTBItem;
    pnUnit: TPanel;
    dcUnit: TTBDock;
    Splitter1: TSplitter;
    TBToolbar1: TTBToolbar;
    TBItem6: TTBItem;
    TBItem7: TTBItem;
    grUnit: TcoDBGridEh;
    taUnit: TADODataSet;
    dsUnit: TDataSource;
    acUnitInsert: TAction;
    acUnitEdit: TAction;
    acUnitDelete: TAction;
    TBSeparatorItem4: TTBSeparatorItem;
    TBItem2: TTBItem;
    taUnitUnitID: TIntegerField;
    acUnitMediumInsert: TAction;
    TBSeparatorItem5: TTBSeparatorItem;
    TBItem3: TTBItem;
    taUnitID: TIntegerField;
    acFilmDelete: TAction;
    TBSeparatorItem6: TTBSeparatorItem;
    TBItem8: TTBItem;
    pnFilter: TPanel;
    edName: TcoEdit;
    cbGroup: TcoDBLookupCombo;
    acMediumEdit: TAction;
    TBItem9: TTBItem;
    acMediumDelete: TAction;
    TBSeparatorItem7: TTBSeparatorItem;
    TBItem10: TTBItem;
    pnNote: TPanel;
    imCover: TcoDBImage;
    taFilmCover: TBlobField;
    taFilmNote: TMemoField;
    meNote: TcoDBMemo;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    taFilmIcon: TIntegerField;
    taFilmDisplay: TStringField;
    acFilmNote: TAction;
    TBItem11: TTBItem;
    TBSeparatorItem8: TTBSeparatorItem;
    taFilmDisplayRange: TStringField;
    pmFilm: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    acFilmAttribut: TAction;
    TBItem12: TTBItem;
    acFilmXMLExport: TAction;
    TBSeparatorItem9: TTBSeparatorItem;
    TBItem13: TTBItem;
    acFilmXMLImportFull: TAction;
    TBItem14: TTBItem;
    TBSubmenuItem1: TTBSubmenuItem;
    TBSeparatorItem10: TTBSeparatorItem;
    TBItem15: TTBItem;
    acFilmXMLImportAttribute: TAction;
    acFilmXMLImportUnit: TAction;
    TBItem16: TTBItem;
    taUnitUnitName: TStringField;
    taFilmSerias: TBooleanField;
    acFilmSerias: TAction;
    TBItem17: TTBItem;
    TBSeparatorItem11: TTBSeparatorItem;
    taFilmHeading: TIntegerField;
    acFilmWatch: TAction;
    spWatch: TADOStoredProc;
    TBSeparatorItem12: TTBSeparatorItem;
    TBItem1: TTBItem;
    acUnitHistory: TAction;
    TBSeparatorItem13: TTBSeparatorItem;
    TBItem18: TTBItem;
    tmGroup: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure acFilmInsertUpdate(Sender: TObject);
    procedure acFilmInsertExecute(Sender: TObject);
    procedure acFilmEditUpdate(Sender: TObject);
    procedure acFilmEditExecute(Sender: TObject);
    procedure acUnitInsertUpdate(Sender: TObject);
    procedure acUnitInsertExecute(Sender: TObject);
    procedure acUnitEditUpdate(Sender: TObject);
    procedure acUnitEditExecute(Sender: TObject);
    procedure acUnitMediumInsertUpdate(Sender: TObject);
    procedure acUnitMediumInsertExecute(Sender: TObject);
    procedure acFilmDeleteUpdate(Sender: TObject);
    procedure acFilmDeleteExecute(Sender: TObject);
    procedure acUnitDeleteExecute(Sender: TObject);
    procedure edNameChange(Sender: TObject);
    procedure cbGroupChange(Sender: TObject);
    procedure acMediumEditUpdate(Sender: TObject);
    procedure acMediumEditExecute(Sender: TObject);
    procedure acMediumDeleteExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure acFilmNoteExecute(Sender: TObject);
    procedure acFilmAttributExecute(Sender: TObject);
    procedure acFilmXMLExportExecute(Sender: TObject);
    procedure acFilmXMLImportFullExecute(Sender: TObject);
    procedure acFilmXMLImportAttributeExecute(Sender: TObject);
    procedure acFilmXMLImportUnitExecute(Sender: TObject);
    procedure acFilmSeriasUpdate(Sender: TObject);
    procedure acFilmSeriasExecute(Sender: TObject);
    procedure grFilmDblClick(Sender: TObject);
    procedure acFilmWatchExecute(Sender: TObject);
    procedure acUnitHistoryExecute(Sender: TObject);
    procedure tmGroupTimer(Sender: TObject);
  private   { Private declarations }
    FEdit:      TFilmEditFR;
    FNote:      TFilmEditAdditionFR;
    FAttribute: TFilmAttributeListFR;
    FUnit:      TUnitEditFR;
    FMedium:    TUnitMediumFR;
    FHistory:   TUnitMediaListFR;
    FHigh:      Integer;
    procedure RefreshFilm( Key: Variant );
    procedure RefreshAttribute;
    procedure RefreshUnit( Key: Variant );
    procedure RefreshMedium( Key: Variant );
    procedure ChangeGroup;
  public    { Public declarations }
  end;

  procedure   FilmRun;
  procedure   FilmDeman( Film: Integer );

  var FilmFM: TFilmFM;

implementation

uses dmCommingData, dmXML, dmFindValue, fmWatch;

{$R *.dfm}
//======================================================================================================================
procedure FilmRun;
begin
  if FilmFM = nil then Application.CreateForm( TFilmFM, FilmFM );
  FilmFM.Show;
end;
//======================================================================================================================
procedure FilmDeman( Film: Integer );
begin
  FilmRun;
  FilmFM.RefreshFilm( Film );
end;
//======================================================================================================================
{ TFilmFM }
//======================================================================================================================
procedure TFilmFM.FormCreate(Sender: TObject);
begin
  inherited;
  DisableItemSelfRun( dmComming.acFilm );
  taFilm.Open;
  taKind.Open;
  taUnit.Open;
end;
//======================================================================================================================
procedure TFilmFM.FormShow(Sender: TObject);
begin
  inherited;
  cbGroup.KeyValue := cbGroup.HelpKeyword;
end;
//======================================================================================================================
procedure TFilmFM.FormResize(Sender: TObject);
begin
  inherited;
  grFilm.HeightBinding( Self );
  cbGroup.Width := pnFilter.ClientWidth - cbGroup.Left;
end;
//======================================================================================================================
procedure TFilmFM.FormDestroy(Sender: TObject);
begin
//  taFilter.SaveRecordToRegistry;
  inherited;
  FilmFM := nil;
end;
//======================================================================================================================
procedure TFilmFM.RefreshFilm( Key: Variant );
  var VL: Variant;
begin
  Screen.Cursor := crHourGlass;
  if Key = CURRENT_RECORD then Key := taFilmID.Value;
  RequeryParameters( taFilm, [ taKindKind.Value, FHigh ]);
  if not taFilm.Locate( 'ID', Key, []) then begin
    VL := dmFind.FindFilm( Key );
    cbGroup.KeyValue  := VL[1];
    FHigh             := VL[0];
    RequeryParameters( taFilm, [ taKindKind.Value, FHigh ]);
    taFilm.Locate( 'ID', Key, []);
  end;
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TFilmFM.RefreshAttribute;
begin
  RefreshFilm( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TFilmFM.RefreshUnit( Key: Variant );
begin
  Screen.Cursor := crHourGlass;
  if Key = CURRENT_RECORD then Key := taUnitUnitID.Value;
  taUnit.Requery;
  taUnit.Locate( 'UnitID', Key, [] );
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TFilmFM.RefreshMedium( Key: Variant );
begin
  Screen.Cursor := crHourGlass;
  if Key = CURRENT_RECORD then Key := taUnitID.Value;
  taUnit.Requery;
  taUnit.Locate( 'ID', Key, [] );
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TFilmFM.ChangeGroup;
begin
  Screen.Cursor := crHourGlass;
  RequeryParameters( taFilm, [ taKindKind.Value, FHigh ]);
  taFilm.Locate( 'Display', Trim(edName.Text), [ loPartialKey ] );
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TFilmFM.edNameChange(Sender: TObject);
begin
  taFilm.Locate( 'DisplayRange', Trim(edName.Text), [ loPartialKey ] );
end;
//======================================================================================================================
procedure TFilmFM.cbGroupChange(Sender: TObject);
begin
  cbGroup.HelpKeyword := taKindKind.Value;
  ChangeGroup;
  tmGroup.Enabled := True;
end;
//======================================================================================================================
procedure TFilmFM.tmGroupTimer(Sender: TObject);
begin
  if ActiveControl = cbGroup then ActiveControl := grFilm;
  tmGroup.Enabled := False;
end;
//======================================================================================================================
procedure TFilmFM.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if ( ActiveControl <> edName) and ( ActiveControl <> cbGroup)
     and ( pnBase.Enabled ) and ( dcMain.Visible ) then
    with edName do begin
      AutoSelect  := False;
      SetFocus;
      Text        := Key;
      SelStart    := 1;
      AutoSelect  := True;
    end;
end;
//======================================================================================================================
procedure TFilmFM.grFilmDblClick(Sender: TObject);
begin
  ClipboardText( taFilmDisplay.Value );
end;
//======================================================================================================================
{  }
//======================================================================================================================
// .
procedure TFilmFM.acFilmInsertUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (taFilm.Active);
end;
//======================================================================================================================
procedure TFilmFM.acFilmInsertExecute(Sender: TObject);
  var h: Integer;
begin
  h := -1;
  if taFilmSerias.Value then h := taFilmID.Value;
  if taFilmID.Value <> taFilmHeading.Value then h := taFilmHeading.Value;
  FEdit.CheckRun( FEdit, Self, RefreshFilm, INSERT_DATA, '', taKindKind.Value, h );
end;
//======================================================================================================================
// .
procedure TFilmFM.acFilmEditUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (taFilm.Active) and (taFilm.RecordCount > 0);
end;
//======================================================================================================================
procedure TFilmFM.acFilmEditExecute(Sender: TObject);
begin
  FEdit.CheckRun( FEdit, Self, RefreshFilm, taFilmID.Value, taKindKind.Value );
end;
//======================================================================================================================
// :
procedure TFilmFM.acFilmNoteExecute(Sender: TObject);
begin
  FNote.CheckRun( FNote, Self, RefreshFilm, taFilmID.Value );
end;
//======================================================================================================================
// 
procedure TFilmFM.acFilmAttributExecute(Sender: TObject);
begin
  FAttribute.CheckRun( FAttribute, Self, RefreshAttribute, taFilmID.Value );
end;
//======================================================================================================================
// :
procedure TFilmFM.acFilmDeleteUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (taFilm.Active) and (taFilm.RecordCount > 0)
                              and (taUnit.Active) and (taUnit.RecordCount = 0);
end;
//======================================================================================================================
procedure TFilmFM.acFilmDeleteExecute(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  DeleteRecord( 'Film', taFilmID );
  taFilm.Prior;
  if taFilm.Bof then taFilm.Next;
  RefreshFilm( CURRENT_RECORD );
end;
//======================================================================================================================
// :
procedure TFilmFM.acFilmSeriasUpdate(Sender: TObject);
begin
  with TAction(Sender) do begin
    Enabled     := (taFilm.Active);
    ImageIndex  := iif( taFilmSerias.Value, 74, 75 );
  end;
end;
//======================================================================================================================
procedure TFilmFM.acFilmSeriasExecute(Sender: TObject);
begin
  if ( taFilmSerias.Value ) then begin
    FHigh := taFilmID.Value;
    RefreshFilm( CURRENT_RECORD );
  end else begin
    FHigh := 0;
    RefreshFilm( taFilmHeading.Value );
  end;
end;
//======================================================================================================================
// :
procedure TFilmFM.acFilmXMLExportExecute(Sender: TObject);
begin
  dmXMLFilm.ExportXLM( taFilmID.Value );
end;
//======================================================================================================================
// :
procedure TFilmFM.acFilmXMLImportFullExecute(Sender: TObject);
begin
  dmXMLFilm.ImportXML;
end;
//======================================================================================================================
procedure TFilmFM.acFilmXMLImportAttributeExecute(Sender: TObject);
begin
  dmXMLFilm.ImportXMLFilmAttribute( taFilmID.Value );
  RefreshFilm( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TFilmFM.acFilmXMLImportUnitExecute(Sender: TObject);
begin
  dmXMLFilm.ImportXMLFilmUnit( taFilmID.Value );
  RefreshFilm( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TFilmFM.acFilmWatchExecute(Sender: TObject);
begin
  spWatch.Parameters[1].Value := taFilmID.Value;
  spWatch.Parameters[2].Value := '+';
  spWatch.ExecProc;
  WatchRun( taFilmID.Value );
end;
//======================================================================================================================
{  ( )}
//======================================================================================================================
// :
procedure TFilmFM.acUnitInsertUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (taFilm.Active) and (taFilm.RecordCount > 0);
end;
//======================================================================================================================
procedure TFilmFM.acUnitInsertExecute(Sender: TObject);
begin
  FUnit.CheckRun( FUnit, Self, RefreshUnit, INSERT_DATA, taFilmID.Value );
end;
//======================================================================================================================
// :
procedure TFilmFM.acUnitEditUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (taUnit.Active) and (taUnit.RecordCount > 0);
end;
//======================================================================================================================
procedure TFilmFM.acUnitEditExecute(Sender: TObject);
begin
  FUnit.CheckRun( FUnit, Self, RefreshUnit, taUnitUnitID.Value );
end;
//======================================================================================================================
// .
procedure TFilmFM.acUnitDeleteExecute(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  DeleteRecord( 'Unit', taUnitUnitID, 'ID' );
  taUnit.Prior;
  RefreshUnit( CURRENT_RECORD );
end;
//======================================================================================================================
{  }
//======================================================================================================================
// .
procedure TFilmFM.acUnitMediumInsertUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (taUnit.Active) and (taUnit.RecordCount > 0);
end;
//======================================================================================================================
procedure TFilmFM.acUnitMediumInsertExecute(Sender: TObject);
begin
  FMedium.CheckRun( FMedium, Self, RefreshMedium, INSERT_DATA, taUnitUnitID.Value );
end;
//======================================================================================================================
// .
procedure TFilmFM.acMediumEditUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (taUnit.Active) and (taUnit.RecordCount > 0)
                              and not taUnitID.IsNull;
end;
//======================================================================================================================
procedure TFilmFM.acMediumEditExecute(Sender: TObject);
begin
  FMedium.CheckRun( FMedium, Self, RefreshMedium, taUnitID.Value, taUnitUnitID.Value );
end;
//======================================================================================================================
// .
procedure TFilmFM.acMediumDeleteExecute(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  DeleteRecord( 'MediumUnit', taUnitID );
  taUnit.Prior;
  RefreshUnit( CURRENT_RECORD );
end;
//======================================================================================================================
//    .
procedure TFilmFM.acUnitHistoryExecute(Sender: TObject);
begin
  FHistory.CheckRun( FHistory, Self, taFilmID.Value );
end;
//======================================================================================================================
end.
