{===================================================================================================

   "Videoteq".

       , .

====================================================================================================

  :

  14.09.2008 [*]    .
  12.09.2008 [+]    .
             [*]       .
  27.05.2008 [*] MakeFilm:  , .
  25.09.2007 [*] MakeFilm:  .
             [+]      .
  11.08.2007 [+] :   ,   .
             [+] MakeFilmItem:    .
             [+] MakeFilm:    .
  22.05.2007 [*]    TStringList.
  03.02.2007 [*]      xls-.
  15.01.2007 [*]    .
  19.10.2006 [+]      Excel.
  16.10.2006 [+]       .
  04.07.2006 [+]     .
  23.09.2005 [+]  ,    .
             [+]     .
             [*]    .
  25.07.2005 [*]   html.
  06.02.2005 [+] .
             [+] , , .
             [+]    :  , .
             [+]   ,   .
  31.01.2005 [+]  .
  17.12.2004 [!]  .

====================================================================================================
  Copyright 20042008 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: fmPublication.pas,v 1.25 2008/09/23 06:15:23 tsk Exp $
===================================================================================================}
unit fmPublication;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, StrUtils,
      PropFilerEh, PropStorageEh, ActnList, TB2Item, TB2Dock, TB2Toolbar, ExtCtrls, DB, ADODB,
      Grids, DBGridEh, scExcelExport, Math,
      // BASE:
      BASEfmRoot,
      // Comming:
      CommingDBGridEh, CommingSystem, CommingADO, CommingOther, CommingFile, CommingMath,
      CommingString,
      // Videoteq:
      fmPublicationPage;

type
  TPublicationFM = class(TBASERootFM)
    taPage: TADODataSet;
    taPageID: TSmallintField;
    taPagePage: TStringField;
    taPageProcedure: TStringField;
    dsPage: TDataSource;
    grPage: TcoDBGridEh;
    acInsert: TAction;
    TBItem2: TTBItem;
    TBItem3: TTBItem;
    TBSeparatorItem4: TTBSeparatorItem;
    TBItem4: TTBItem;
    TBSeparatorItem5: TTBSeparatorItem;
    TBItem5: TTBItem;
    acEdit: TAction;
    acDelete: TAction;
    acDo: TAction;
    taPubl: TADODataSet;
    taPublName: TStringField;
    taPublID: TIntegerField;
    taUnit: TADODataSet;
    taUnitName: TStringField;
    taFilm: TADODataSet;
    taFilmID: TIntegerField;
    taFilmDisplay: TStringField;
    taFilmCover: TBlobField;
    taFilmNote: TMemoField;
    taGroup: TADODataSet;
    taGroupKind: TStringField;
    taGroupName: TStringField;
    taExcel: TADODataSet;
    taExcelFilm: TStringField;
    taExcelUnit: TStringField;
    eeVideo: TscExcelExport;
    taFilmSub: TStringField;
    taFilmAddition: TStringField;
    taFilmHeading: TIntegerField;
    taFilmSerias: TSmallintField;
    taSerias: TADODataSet;
    taSeriasID: TIntegerField;
    taSeriasName: TStringField;
    taSeriasIcon: TIntegerField;
    taFilmHighDisplay: TStringField;
    taPublPage: TBooleanField;
    taPublUnit: TIntegerField;
    taPublPageFilm: TBooleanField;
    taPublBookmark: TStringField;
    taFilmUnit: TIntegerField;
    taPublStep: TSmallintField;
    procedure FormCreate(Sender: TObject);
    procedure acInsertUpdate(Sender: TObject);
    procedure acInsertExecute(Sender: TObject);
    procedure acEditUpdate(Sender: TObject);
    procedure acEditExecute(Sender: TObject);
    procedure acDeleteExecute(Sender: TObject);
    procedure acDoExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure taPublCalcFields(DataSet: TDataSet);
  private   { Private declarations }
    FComp: String;
    FPage: TPublicationPageFR;
    procedure RefreshPage( Key: Variant );
    procedure MakeExcel( Zip: String );
    procedure MakeFilm;
    procedure MakeFilmList( Proc, Page: String );
    procedure MakeFilmItem( ID: Integer; Name: String; Link, Sub, Film, GoMark: Boolean; var HTML: TStringList );
  public    { Public declarations }
  end;

  procedure   PublicationRun;

  var PublicationFM: TPublicationFM;

resourcestring
  rsTitleBeg = '<!-- Title Begin -->';
  rsTitleEnd = '<!-- Title End -->';
  rsBeg      = '<!-- Begin -->';
  rsEnd      = '<!-- End -->';

implementation

uses dmCommingData;

{$R *.dfm}
//==================================================================================================
procedure PublicationRun;
begin
  if PublicationFM = nil then Application.CreateForm(TPublicationFM, PublicationFM);
  PublicationFM.Show;
end;
//==================================================================================================
{ TPublicationFM }
//==================================================================================================
procedure TPublicationFM.FormCreate(Sender: TObject);
begin
  inherited;
  DisableItemSelfRun( dmComming.acPublication );
  FComp := GetCompName;
  RequeryParameters( taPage, [ FComp ]);
end;
//==================================================================================================
procedure TPublicationFM.FormDestroy(Sender: TObject);
begin
  PublicationFM := nil;
  inherited;
end;
//==================================================================================================
procedure TPublicationFM.RefreshPage(Key: Variant);
begin
  Screen.Cursor := crHourGlass;
  if Key = CURRENT_RECORD then Key := taPageID.Value;
  taPage.Requery;
  taPage.Locate( 'ID', Key, [] );
  Screen.Cursor := crDefault;
end;
//==================================================================================================
procedure TPublicationFM.taPublCalcFields(DataSet: TDataSet);
begin
  taPublPageFilm.Value := ( taPublPage.Value ) or ( taPublUnit.Value > 1 );
end;
//==================================================================================================
{  }
//==================================================================================================
// :
procedure TPublicationFM.acInsertUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( not Empty( FComp )) and ( taPage.Active );
end;
//==================================================================================================
procedure TPublicationFM.acInsertExecute(Sender: TObject);
begin
  FPage.CheckRun( FPage, Self, RefreshPage, INSERT_DATA, FComp );
end;
//==================================================================================================
// .
procedure TPublicationFM.acEditUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taPage.Active ) and ( taPage.RecordCount > 0 );
end;
//==================================================================================================
procedure TPublicationFM.acEditExecute(Sender: TObject);
begin
  FPage.CheckRun( FPage, Self, RefreshPage, taPageID.Value, FComp );
end;
//==================================================================================================
// .
procedure TPublicationFM.acDeleteExecute(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  DeleteRecord( 'Publication', taPageID );
  taPage.Prior;
  RefreshPage( CURRENT_RECORD );
end;
//==================================================================================================
// .
procedure TPublicationFM.acDoExecute(Sender: TObject);
  var Key: Variant;
begin
  Key  := taPageID.Value;
  taPage.First;
  while not taPage.Eof do begin
    if taPageProcedure.Value = 'PubFilm' then begin
      //  :
      taFilm.Open;
      while not taFilm.Eof do begin
        MakeFilm;
        taFilm.Next;
      end;
      taFilm.Close;
    end else if taPageProcedure.Value = 'PubExcel' then begin
      MakeExcel( taPagePage.Value );
    end else begin
      // :
      MakeFilmList( taPageProcedure.Value, taPagePage.Value );
    end;
    taPage.Next;
  end;
  RefreshPage( Key );
end;
//==================================================================================================
procedure TPublicationFM.MakeFilmList( Proc, Page: String );
  var HTML, BMR: TStringList;
      i, p: Integer;
      PB, PN, BDiv: String;
  function PageBookmark( n: Integer ): String;
  begin
    if n = 1 then Result := PN else Result := PN + '.' + IntToAlpha( n - 1, 2 );
  end;

begin
  PN    := ExtractFileNameNoExt( Page );
  p     := 0;
  HTML  := TStringList.Create;
  BMR   := TStringList.Create;
  taPubl.CommandText := Proc;
  taPubl.Open;
  // :
  if taPubl.RecordCount > taPublStep.Value then begin
    HTML.Add('<div id="letter">');
    while not taPubl.Eof do begin
      BMR.Add( AnsiUpperCase( taPublBookmark.Value ));
      HTMl.Add('<a href="' + PageBookmark( BMR.Count ) + '.htm">' + taPublBookmark.Value + '</a>');
      for i := 0 to taPublStep.Value do taPubl.Next;
    end;
    HTML.Add('</div>');
    BDiv := HTML.Text;
    p := 1;
  end;
  // :
  taPubl.First;
  HTML.Add('<ul>');
  while not taPubl.Eof do begin
    //   :
    if ( p > 0 ) and ( p < BMR.Count ) and ( AnsiUpperCase( taPublBookmark.Value ) >= BMR[p] ) then begin
      //  :
      HTML.Add('</ul>');
      PB := ExtractFileDir( Page ) + '\' + PageBookmark( p ) + '.htm';
      ReplaceFileLine( PB, rsBeg, rsEnd, HTML, Page );
      //  :
      HTML.Text := BDiv;
      HTML.Add('<ul>');
      Inc( p );
    end;
    MakeFilmItem( taPublID.Value, taPublName.Value, taPublPageFilm.Value, True, False, False, HTML );
    taPubl.Next;
  end;
  taPubl.Close;
  HTML.Add('</ul>');
  if p > 0
    then PB := ExtractFileDir( Page ) + '\' + PageBookmark( p ) + '.htm'
    else PB := Page;
  ReplaceFileLine( PB, rsBeg, rsEnd, HTML, Page );
  HTML.Free;
  BMR.Free;
end;
//==================================================================================================
procedure TPublicationFM.MakeExcel( Zip: String );
  var XLS: String;
begin
//
//  Exit;
//
  XLS := ExtractFilePathNameNoExt( Zip ) + '.xls';
  taGroup.Open;
//  eeVideo.ConnectTo := ctNewExcel;
  while not taGroup.Eof do begin
    RequeryParameters( taExcel, [ taGroupKind.Value ]);
    eeVideo.WorksheetName := LeftStr( taGroupName.Value, 30 );
//    eeVideo.Dataset       := taExcel;
    eeVideo.ExportDataset;
//    eeVideo.Disconnect;
//    eeVideo.ConnectTo := ctNewWorksheet;
    taGroup.Next;
  end;
  eeVideo.SaveAs( XLS, ffXLS );
  eeVideo.Disconnect;
  taExcel.Close;
  taGroup.Close;
  ZIPFile( XLS );
end;
//==================================================================================================
procedure TPublicationFM.MakeFilm;
  var HTML, Desc: TStringList;
      PageFile: String;
      BlobStream: TStream;
      i: Integer;
begin
  HTML := TStringList.Create;
  Desc := TStringList.Create;
  //  :
  if taFilmHeading.IsNull //   
    then HTML.Add('<title>' + taFilmDisplay.Value + '</title>')
    else HTML.Add('<title>' + taFilmHighDisplay.Value
                            + '. ' + taFilmDisplay.Value + '</title>');
  PageFile := ExtractFilePath( taPagePage.Value ) + IntToAlpha( taFilmID.Value, 4) + '.htm';
  ReplaceFileLine( PageFile, rsTitleBeg, rsTitleEnd, HTML, taPagePage.Value );
  //  :
  HTML.Clear;
  if taFilmHeading.IsNull then //   
    if taFilmAddition.IsNull then begin
      HTML.Add( '<h2>' + taFilmDisplay.Value + '</h2>');
    end else begin
      //   ,  :
      HTML.Add( '<h2 class="filmname">' + taFilmDisplay.Value + '</h2>');
      HTML.Add( '<p class="filmdescrip">' + taFilmAddition.Value + '</p>');
    end
  else
    if taFilmAddition.IsNull then begin
      HTML.Add( '<h2 class="filmname">' + taFilmHighDisplay.Value + '</h2>');
      HTML.Add( '<h3>' + taFilmDisplay.Value + '</h3>');
    end else begin
      //   ,  :
      HTML.Add( '<h2 class="filmname">' + taFilmHighDisplay.Value + '</h2>');
      HTML.Add( '<h3 class="filmname">' + taFilmDisplay.Value + '</h3>');
      HTML.Add( '<p class="filmdescrip">' + taFilmAddition.Value + '</p>');
    end;
  //  
  if ( not taFilmCover.IsNull ) or ( not taFilmSub.IsNull ) or ( not taFilmNote.IsNull ) then begin
    HTML.Add('<table><tr><td>');
    //       HTML:
    if not taFilmCover.IsNull then begin
      StringListAddFormat( HTML,
                           '<img border="1" src="%s.jpg" align="left" alt="%s" class="pic">',
                           [ IntToAlpha( taFilmID.Value, 4), taFilmDisplay.Value ] );
      taFilmCover.SaveToFile( ExtractFilePath( taPagePage.Value )
                                + IntToAlpha( taFilmID.Value, 4) + '.jpg');
    end;
    //     , :
    if not taFilmSub.IsNull
      then HTML.Add( '<p>' + taFilmSub.Value + '.</p>');
    //       :
    if not taFilmNote.IsNull then begin
      BlobStream := taFilm.CreateBlobStream(taFilmNote, bmRead);
      try
        Desc.LoadFromStream(BlobStream);
      finally
        BlobStream.Free;
      end;
    end;
    for i := 0 to Desc.Count - 1 do
      if Length( Desc[i] ) > 0 then HTML.Add( '<p>' + Desc[i] + '</p>' );
    HTML.Add('</td></tr></table>');
    HTML.Add( '<hr>' );
  end;
  // :
//  if (taFilmUnit.Value > 1) then begin
    HTML.Add( '<a name="unit"></a>' );
    HTML.Add( '<p>' );
    RequeryParameters( taUnit, [ taFilmID.Value ]);
    while not taUnit.Eof do begin
      HTML.Add( taUnitName.Value + '<br/>' );
      taUnit.Next;
    end;
    taUnit.Close;
    HTML.Add( '</p>' );
//  end;
  // :
  if taFilmSerias.Value > 0 then begin
    RequeryParameters( taSerias, [ taFilmID.Value ]);
    if taSerias.RecordCount > 0 then begin
      HTML.Add('<ul>');
      while not taSerias.Eof do begin
        MakeFilmItem( taSeriasID.Value, taSeriasName.Value, (taSeriasIcon.Value > 0), False, True, False, HTML );
        taSerias.Next;
      end;
      HTML.Add('</ul>');
    end;
    taSerias.Close;
  end;
  //   :
  if taFilmHeading.Value > 0 then begin
    //  :
    HTML.Add( '<hr>' );
    HTML.Add( '<h3><a href="'+ IntToAlpha( taFilmHeading.Value, 4) + '.htm"><b>'
              + taFilmHighDisplay.Value + '</b></a></h3>');
    RequeryParameters( taSerias, [ taFilmHeading.Value ]);
    if taSerias.RecordCount > 0 then begin
      HTML.Add('<ul>');
      while not taSerias.Eof do begin
        //    :
        if taFilmID.Value = taSeriasID.Value then begin
          MakeFilmItem( -1, taSeriasName.Value, False, False, True, True, HTML );
        end else begin
          MakeFilmItem( taSeriasID.Value, taSeriasName.Value, (taSeriasIcon.Value > 0), False, True, False, HTML );
        end;
        taSerias.Next;
      end;
      HTML.Add('</ul>');
    end;
    taSerias.Close;
  end;
  //  .
  ReplaceFileLine( PageFile, rsBeg, rsEnd, HTML, taPagePage.Value );
end;
//==================================================================================================
procedure TPublicationFM.MakeFilmItem( ID: Integer; Name: String; Link, Sub, Film, GoMark: Boolean;
                                       var HTML: TStringList );
  var Page: String;
begin
  Page := IntToAlpha( ID, 4) + '.htm';
  if Sub then Page := 'film/' + Page;
  if Link
    then HTML.Add( '<li>&nbsp;<a href="'+ Page + '"><b>' + Name + '</b></a>')
    else HTML.Add( '<li>&nbsp;<b>' + Name + '</b>');
//  Page := '';
  // , :
  RequeryParameters( taUnit, [ ID ]);
  if taUnit.RecordCount > 0 then begin
    HTML.Add( '<small>' );
    while not taUnit.Eof do begin
      if Film then begin
        HTML.Add( '<br/>' + taUnitName.Value );
        taUnit.Next;
      end else begin
        HTML.Add( '<br/>' + taUnitName.Value + iif( taUnit.RecordCount > 1, '', '' ));
        taUnit.Last;
      end
    end;
    HTML.Add( '</small>' );
  end else if GoMark then begin
    HTML.Add( '<small><br/><a href="#unit">^^^</a></small>' );
  end else begin
    HTML.Add( '<small><br/></small>' );
  end;;
  HTML.Add( '</li>' );
end;
//==================================================================================================
end.
