{===================================================================================================

   "Videoteq".

    , , .

====================================================================================================

  :

  06.02.2005 [+]    .
             [+]    .
             [+]  .
             [+]  .
  17.12.2004 [!]  .

====================================================================================================
  Copyright 20042005 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: fmPublicationPage.pas,v 1.3 2007/09/03 06:00:56 tsk Exp $
===================================================================================================}
unit fmPublicationPage;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ADODB, ExtCtrls, DB,
      StdCtrls, Mask, DBCtrls,
      // BASE:
      BASEfrEdit, BASEsfDBEdit, BASEsfDBEditButton, BASEsfDBComboBox,
      // Comming:
      CommingADO, CommingButton;

type

  TPublicationPageFR = class( TBASEEditFR )
    frComputer: TBASEDBEditSF;
    taDataID: TSmallintField;
    taDataComputer: TStringField;
    taDataPage: TStringField;
    taDataProcedure: TStringField;
    frPage: TBASEDBEditButtonSF;
    dgPage: TOpenDialog;
    frProcedure: TBASEDBComboBoxSF;
    taProc: TADODataSet;
    procedure frPagebtLabelClick(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
    procedure CheckRun( var AFrame: TPublicationPageFR; AOwner: TComponent; PAPost: TAfterPostKey;
                        ID: Integer; Comp: String = '' );
  end;

implementation

uses dmCommingData;

{$R *.DFM}
//==================================================================================================
{ TPublicationPageFR }
//==================================================================================================
procedure TPublicationPageFR.CheckRun( var AFrame: TPublicationPageFR; AOwner: TComponent;
                                     PAPost: TAfterPostKey; ID: Integer; Comp: String );
begin
  Screen.Cursor := crHourGlass;
  if AFrame = nil then AFrame := TPublicationPageFR.CreateComming( AOwner, PAPost );
  with AFrame do begin
    frProcedure.FillValues( taProc );
    RequeryParameters( taData, [ ID ]);
    if taData.RecordCount = 0 then begin
      taData.Insert;
      taDataComputer.Value := Comp;
    end;
    ShowModal;
    frPage.edField.SetFocus;
  end;
  Screen.Cursor := crDefault;
end;
//==================================================================================================
procedure TPublicationPageFR.frPagebtLabelClick(Sender: TObject);
begin
  inherited;
  dgPage.FileName := taDataPage.Value;
  if dgPage.Execute then begin
    if not ( taData.State in [ dsInsert, dsEdit ]) then taData.Edit;
    taDataPage.Value := dgPage.FileName;
  end;
end;
//==================================================================================================
end.
