/*=================================================================================================

   "Videoteq".

      .

===================================================================================================

  :

  22.03.2015 [-]  .
  14.09.2008 [*] PubLast:     ; 10     .
  12.09.2008 [*] PubLast:    .
             [*]       .
  08.09.2008 [+] PubDocumentation:  .
  28.05.2008 [*]     .
  14.02.2008 [*] PubFilm:    ", ".
  17.09.2007 [*] ListPubFilmUnit:  .
  25.09.2007 [*]       .
             [+] ViewPubFilm:   .
             [-] .
  11.08.2007 [*]   :  .
             [+] ListPubFilmSerias:  .
             [-] PubAll:    ,      .
             [-] PubBabylon5, PubFarscape, PubTwinPeaks, Pub007, PubExpert:   .
             [-]       .
  31.07.2007 [*] PubFilm:    . 
  24.06.2007 [*] PubExcel:  ViewUnitDisplay.
             [*] ListPubFilmUnit:  ViewUnitDisplay.
  30.04.2007 [+] PubExpert:  "  ".
             [+] PubTheatre: , .
  31.01.2007 [*]       "L".
  17.01.2007 [+] PubFilm:     .
  12.01.2007 [+] ListPubFilmUnit:  .
  16.10.2006 [+] PubExcel:   xls-.
  26.09.2006 [+] PubTwinPeaks:  "Twin Peaks".
  15.08.2006 [+] PubFarscape:  "  ".
  04.07.2006 [+] PubAll:   .
  12.04.2006 [+] Pub007: James Bond, 007.
  05.04.2006 [*]      DisplayRange.
  31.03.2006 [+] PubFilmClear:    .
  15.03.2006 [*] PubFilm:    .
  31.10.2005 [+] PubSport: .
  26.09.2005 [+] PubBabylon5:   5.
  23.09.2005 [+] PubFilm:  .
             [+]   .
  23.03.2005 [+] PubCartoonAnime: anime ( ).
  22.03.2005 [+] ListPubFilmUnit:   .
             [+] PubLast: 20  .
             [+] PubFormulaOne:  1.
             [*]     .
  06.02.2005 [+] PubMusic: .
             [+] PubCartoonRus:  ( ).
             [+] PubCartoonLat:  ( ).
             [+] PubRussian: ,  .
             [+] ListPubPage:    .
  31.01.2005 [+] LookupPubProcedure:  ,   .
             [+] PubForeignRus:   ( ).
             [+] PubForeignLat:   ( ).
             [+]  .
  17.12.2004 [!]  .

===================================================================================================
  Copyright 20042008 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: scPublication.sql,v 1.34 2015/03/30 10:32:29 tsk Exp $
=================================================================================================*/
USE Videoteq
--
EXECUTE CheckDropView      'ViewPubFilm'
EXECUTE CheckDropProcedure 'PubForeign'
EXECUTE CheckDropProcedure 'PubRussian'
EXECUTE CheckDropProcedure 'PubCartoonLat'
EXECUTE CheckDropProcedure 'PubCartoonRus'
EXECUTE CheckDropProcedure 'PubCartoonAnime'
EXECUTE CheckDropProcedure 'PubMusic'
EXECUTE CheckDropProcedure 'PubJapan'
EXECUTE CheckDropProcedure 'PubFormulaOne'
EXECUTE CheckDropProcedure 'PubSport'
EXECUTE CheckDropProcedure 'PubTheatre'
EXECUTE CheckDropProcedure 'PubDocumentation'
EXECUTE CheckDropProcedure 'PubAll'
EXECUTE CheckDropProcedure 'PubFilm'
EXECUTE CheckDropProcedure 'PubFilmClear'
EXECUTE CheckDropProcedure 'PubLast'
EXECUTE CheckDropProcedure 'PubExcel'
--
EXECUTE CheckDropProcedure 'ListPubPage'
EXECUTE CheckDropProcedure 'ListPubFilmUnit'
EXECUTE CheckDropProcedure 'ListPubFilmSerias'
EXECUTE CheckDropProcedure 'LookupPubProcedure'
--
GO
--=================================================================================================
CREATE VIEW ViewPubFilm
AS
--
  SELECT ID,
         Display AS Name,
         CAST( Icon + ISNULL(Serias,0)+ISNULL(DATALENGTH(DisplayNote),0) AS BIT) AS [Page], 
         (SELECT COUNT(*) FROM Unit WHERE (Unit.Film = Film.ID)) AS [Unit],
         LEFT( Film.DisplayRange, FilmKind.Bookmark) AS Bookmark,
         FilmKind.Step,
         [Group], Heading, 
         DisplayRange AS [Range], 
         Film.Publication
    FROM Film
      INNER JOIN FilmKind ON Film.[Group] = FilmKind.Kind
--
GO
--=================================================================================================
--CREATE PROCEDURE PubForeign
--AS
--  SELECT ID, Name, [Page], [Unit], Bookmark, Step
--    FROM ViewPubFilm
--    WHERE ([Group] = 'V') AND (Heading IS NULL)
--    ORDER BY [Range]
----
--GO
----=================================================================================================
--CREATE PROCEDURE PubRussian
--AS
--  SELECT ID, Name, [Page], [Unit], Bookmark, Step
--    FROM ViewPubFilm
--    WHERE ([Group] = 'R') AND (Heading IS NULL)
--    ORDER BY [Range]
----
--GO
----=================================================================================================
--CREATE PROCEDURE PubCartoonLat
--AS
--  SELECT ID, Name, [Page], [Unit], Bookmark, Step
--    FROM ViewPubFilm
--    WHERE ([Group] = 'C') AND (Heading IS NULL)
--    ORDER BY [Range]
----
--GO
----=================================================================================================
--CREATE PROCEDURE PubCartoonRus
--AS
--  SELECT ID, Name, [Page], [Unit], Bookmark, Step
--    FROM ViewPubFilm
--    WHERE ([Group] = 'L') AND (Heading IS NULL)
--    ORDER BY [Range]
----
--GO
----=================================================================================================
--CREATE PROCEDURE PubCartoonAnime
--AS
--  SELECT ID, Name, [Page], [Unit], Bookmark, Step
--    FROM ViewPubFilm
--    WHERE ([Group] = 'A') AND (Heading IS NULL)
--    ORDER BY [Range]
----
--GO
----=================================================================================================
--CREATE PROCEDURE PubJapan
--AS
--  SELECT ID, Name, [Page], [Unit], Bookmark, Step
--    FROM ViewPubFilm
--    WHERE ([Group] = 'J') AND (Heading IS NULL)
--    ORDER BY [Range]
----
--GO
----=================================================================================================
--CREATE PROCEDURE PubMusic
--AS
--  SELECT ID, Name, [Page], [Unit], Bookmark, Step
--    FROM ViewPubFilm
--    WHERE ([Group] = 'M') AND (Heading IS NULL)
--    ORDER BY [Range]
----
--GO
----=================================================================================================
--CREATE PROCEDURE PubFormulaOne
--AS
--  SELECT ID, Name, [Page], [Unit], Bookmark, Step
--    FROM ViewPubFilm
--    WHERE ([Group] = 'F') AND (Heading IS NULL)
--    ORDER BY [Range]
----
--GO
----=================================================================================================
--CREATE PROCEDURE PubSport
--AS
--  SELECT ID, Name, [Page], [Unit], Bookmark, Step
--    FROM ViewPubFilm
--    WHERE ([Group] = 'S') AND (Heading IS NULL)
--    ORDER BY [Range]
----
--GO
----=================================================================================================
--CREATE PROCEDURE PubTheatre
--AS
--  SELECT ID, Name, [Page], [Unit], Bookmark, Step
--    FROM ViewPubFilm
--    WHERE ([Group] = 'E') AND (Heading IS NULL)
--    ORDER BY [Range]
----
--GO
----=================================================================================================
--CREATE PROCEDURE PubDocumentation
--AS
--  SELECT ID, Name, [Page], [Unit], Bookmark, Step
--    FROM ViewPubFilm
--    WHERE ([Group] = 'D') AND (Heading IS NULL)
--    ORDER BY [Range]
----
--GO
----=================================================================================================
--CREATE PROCEDURE PubFilm
--AS
--  SELECT Film.ID,
--         Film.FilmTitle AS Display,
--         Film.Cover,
--         CASE WHEN ( Film.Year IS NULL ) THEN Film.Country
--           ELSE ISNULL(Film.Country + ', ', '') + ISNULL( CAST(Film.Year AS VARCHaR) + ' ', '' ) 
--           END AS Sub,
--         Film.DisplayNote AS Note,
--         Film.Addition,
--         Film.Heading, Film.Serias, 
--         High.FilmTitle AS HighDisplay,
--         (SELECT COUNT(*) FROM Unit WHERE (Unit.Film = Film.ID)) AS [Unit]
--    FROM Film
--      LEFT OUTER JOIN Film AS High ON Film.Heading = High.ID    
--    WHERE (NOT Film.Publication IS NULL ) 
--      AND ((Film.Icon > 0) OR (Film.Serias > 0) OR (DATALENGTH(Film.DisplayNote) > 0 ) OR
--           (SELECT COUNT(*) FROM Unit WHERE (Unit.Film = Film.ID)) > 1)
----
--GO
--=================================================================================================
--CREATE PROCEDURE PubFilmClear
--AS
--  UPDATE Film
--    SET Publication = NULL
--    WHERE (Publication = 1)
--
--  SELECT ID, Name, [Page], [Unit], Bookmark, Step
--    FROM ViewPubFilm
--    WHERE (1 = 0)
----
--GO
--=================================================================================================
--CREATE PROCEDURE PubLast
--AS
--  --
--  SELECT ID, Name, [Page], [Unit], CAST(NULL AS VARCHAR(2)) as Bookmark, 1000 as Step
--    FROM ViewPubFilm
--    WHERE (Heading IS NULL) AND (NOT Publication IS NULL)
--    ORDER BY Publication DESC
--  --  .
--  UPDATE Film
--    SET Publication = NULL
--    WHERE (NOT Heading IS NULL)
--  -- .
--  DECLARE @PG INT, @PU DATETIME
--  SELECT @PG = COUNT(*) FROM Film
--    WHERE (NOT (Publication IS NULL)) AND (Heading IS NULL)
--  WHILE ( @PG > 15 ) BEGIN
--    SELECT @PU = MIN(DISTINCT Publication) FROM Film
--      WHERE (NOT (Publication IS NULL)) AND (Heading IS NULL)
--    UPDATE Film
--      SET Publication = NULL
--      WHERE (Publication = @PU)
--    SELECT @PG = COUNT(*) FROM Film
--      WHERE (NOT (Publication IS NULL)) AND (Heading IS NULL)
--  END
----
--GO
--=================================================================================================
CREATE PROCEDURE ListPubPage @COMP VARCHAR(20)
AS
  SELECT ID, Page, [Procedure]
    FROM Publication
    WHERE (Computer = @COMP)
    ORDER BY [Procedure]
--
GO
--=================================================================================================
CREATE PROCEDURE ListPubFilmUnit @ID INT
AS
  SELECT Display AS Name
    FROM ViewUnitDisplay
    WHERE (Film = @ID)
    ORDER BY [Order]
--
GO
--=================================================================================================
CREATE PROCEDURE ListPubFilmSerias @ID INT
AS
  SELECT ID,
         Display AS Name,
         Icon + ISNULL(Serias,0)+ISNULL(DATALENGTH(DisplayNote),0) AS Icon
    FROM Film
    WHERE (Heading = @ID)
    ORDER BY DisplayRange
--
GO
--=================================================================================================
CREATE PROCEDURE LookupPubProcedure
AS
  SELECT name AS [NameProcedure]
    FROM  sysobjects
    WHERE (type = 'P') AND (name LIKE 'Pub%')
    ORDER BY name
--
GO
--=================================================================================================
CREATE PROCEDURE PubExcel @GR CHAR(1)
AS
  SELECT Film.Display AS Film, 
         ViewUnitDisplay.Display AS Unit
    FROM Film
      INNER JOIN Unit ON Film.ID = Unit.Film
      INNER JOIN ViewUnitDisplay ON Unit.ID = ViewUnitDisplay.ID 
    WHERE ([Group] = @GR)
    ORDER BY DisplayRange
--
GO
--=================================================================================================
-- 
-- SELECT * FROM ViewPubFilm ORDER BY [Range]
-- EXECUTE PubForeign
-- EXECUTE PubRussian
-- EXECUTE PubCartoonLat
-- EXECUTE PubCartoonRus
-- EXECUTE PubCartoonAnime
-- EXECUTE PubJapan
-- EXECUTE PubMusic
-- EXECUTE PubTheatre
-- EXECUTE PubSport
-- EXECUTE PubFormulaOne
-- EXECUTE PubDocumentation
-- EXECUTE PubExpert
-- EXECUTE PubFilm
-- EXECUTE PubLast
-- EXECUTE PubExcel 'M'
--
-- EXECUTE LookupPubProcedure
-- EXECUTE ListPubPage 'TSK-HOME'
-- EXECUTE ListPubFilmUnit 430
-- EXECUTE ListPubFilmSerias 938