{===================================================================================================

   "Videoteq".

    , , .

====================================================================================================

  :

  28.05.2008 [+]     .
  16.05.2008 [+]  ""    -.
  11.11.2007 [*]   ""     HDD.
  13.04.2005 [+]  -.
  15.03.2005 [*]      .
             [+]  .
  17.12.2004 [!]  .

====================================================================================================
  Copyright 20042008 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: frMediumEdit.pas,v 1.6 2008/05/28 05:00:20 tsk Exp $
===================================================================================================}
unit frMediumEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ADODB, ExtCtrls, DB,
      StdCtrls, Mask, DBCtrls,
      // BASE:
      BASEfrEdit, BASEsfDBEdit, BASEsfDBLookupCombo,
      // Comming:
      CommingButton, CommingADO;

type

  TMediumEditFR = class( TBASEEditFR )
    frNumber: TBASEDBEditSF;
    frPlace: TBASEDBLookupComboSF;
    frKind: TBASEDBLookupComboSF;
    taDataID: TAutoIncField;
    taDataPlace: TSmallintField;
    taDataKind: TSmallintField;
    taDataNumber: TStringField;
    frSerial: TBASEDBEditSF;
    taDataSerial: TStringField;
  private   { Private declarations }
  public    { Public declarations }
    procedure CheckRun( var AFrame: TMediumEditFR; AOwner: TComponent; PAPost: TAfterPostKey;
                        ID: Integer; Place: Integer = -1; Kind: Integer = -1; Number: String = '' );
  end;

implementation

uses dmCommingData, dmLookupComboData;

{$R *.DFM}
//==================================================================================================
{ TMediumEditFR }
//==================================================================================================
procedure TMediumEditFR.CheckRun( var AFrame: TMediumEditFR; AOwner: TComponent;
                                   PAPost: TAfterPostKey; ID, Place: Integer;
                                                                    Kind: Integer; Number: String );
begin
  Screen.Cursor := crHourGlass;
  if AFrame = nil then AFrame := TMediumEditFR.CreateComming( AOwner, PAPost );
  with AFrame do begin
    RequeryParameters( taData, [ ID ]);
    frPlace.RequeryLookup( dmCombo.dsPlace );
    frKind.RequeryLookup( dmCombo.dsMKind );
    if taData.RecordCount = 0 then begin
      taData.Insert;
      taDataPlace.Value := Place;
      if Kind > 0 then begin
        taDataKind.Value    := Kind;
        taDataNumber.Value  := Number;
      end;
    end;
    ShowModal;
  end;
  Screen.Cursor := crDefault;
end;
//==================================================================================================
end.
