{=======================================================================================================================

   "Videoteq".

       , .

========================================================================================================================

  :

  07.10.2012 [+]  .
  17.12.2004 [!]  .

========================================================================================================================
  Copyright 20042012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: fmWatch.pas,v 1.1 2012/10/22 07:08:35 tsk Exp $
=======================================================================================================================}
unit fmWatch;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs,
      PropFilerEh, PropStorageEh, ActnList, TB2Item, TB2Dock, TB2Toolbar, ExtCtrls, DB, ADODB,
      Grids, DBGridEh, StdCtrls, Mask, DBCtrls, Menus, Clipbrd,
      // BASE:
      BASEfmRoot, BASEsfDBLookupCombo,
      // Comming:
      CommingDBGridEh, CommingADO, CommingFlat, CommingParameterTable, CommingLookupFlat,
      CommingDBImage, CommingOther,
      // Videoteq:
      frFilmEdit;

type
  TWatchFM = class(TBASERootFM)
    taFilm: TADODataSet;
    dsFilm: TDataSource;
    grFilm: TcoDBGridEh;
    taFilmID: TIntegerField;
    TBItem4: TTBItem;
    acFilmEdit: TAction;
    TBItem5: TTBItem;
    pnUnit: TPanel;
    Splitter1: TSplitter;
    grUnit: TcoDBGridEh;
    taUnit: TADODataSet;
    dsUnit: TDataSource;
    taUnitUnitID: TIntegerField;
    taUnitID: TIntegerField;
    pnNote: TPanel;
    imCover: TcoDBImage;
    taFilmCover: TBlobField;
    taFilmNote: TMemoField;
    meNote: TcoDBMemo;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    taFilmIcon: TIntegerField;
    taUnitUnitName: TStringField;
    taFilmName: TStringField;
    acWatshDone: TAction;
    spWatch: TADOStoredProc;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure acFilmEditUpdate(Sender: TObject);
    procedure acFilmEditExecute(Sender: TObject);
    procedure grFilmDblClick(Sender: TObject);
    procedure acWatshDoneExecute(Sender: TObject);
  private   { Private declarations }
    FEdit:      TFilmEditFR;
    procedure RefreshFilm( Key: Variant );
  public    { Public declarations }
  end;

  procedure WatchRun( ID: Integer = -1);

  var WatchFM: TWatchFM;

implementation

uses dmCommingData, fmFilm;
{$R *.dfm}
//======================================================================================================================
procedure WatchRun( ID: Integer );
begin
  if WatchFM = nil then Application.CreateForm( TWatchFM, WatchFM );
  WatchFM.Show;
  if ID > 0 then WatchFM.RefreshFilm( ID );
end;
//======================================================================================================================
{ TWatchFM }
//======================================================================================================================
procedure TWatchFM.FormCreate(Sender: TObject);
begin
  inherited;
  DisableItemSelfRun( dmComming.acWatch );
  taFilm.Open;
  taUnit.Open;
end;
//======================================================================================================================
procedure TWatchFM.FormResize(Sender: TObject);
begin
  inherited;
  grFilm.HeightBinding( Self );
end;
//======================================================================================================================
procedure TWatchFM.FormDestroy(Sender: TObject);
begin
  inherited;
  WatchFM := nil;
end;
//======================================================================================================================
procedure TWatchFM.RefreshFilm( Key: Variant );
begin
  Screen.Cursor := crHourGlass;
  if Key = CURRENT_RECORD then Key := taFilmID.Value;
  RequeryParameters( taFilm, [] );
  taFilm.Locate( 'ID', Key, []);
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TWatchFM.grFilmDblClick(Sender: TObject);
begin
  FilmDeman( taFilmID.Value );
end;
//======================================================================================================================
{  }
//======================================================================================================================
// .
procedure TWatchFM.acFilmEditUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (taFilm.Active) and (taFilm.RecordCount > 0);
end;
//======================================================================================================================
procedure TWatchFM.acFilmEditExecute(Sender: TObject);
begin
  FEdit.CheckRun( FEdit, Self, RefreshFilm, taFilmID.Value, 'F' );
end;
//======================================================================================================================
procedure TWatchFM.acWatshDoneExecute(Sender: TObject);
begin
  spWatch.Parameters[1].Value := taFilmID.Value;
  spWatch.Parameters[2].Value := '-';
  spWatch.ExecProc;
  taFilm.Prior;
  RefreshFilm( CURRENT_RECORD );
end;
//======================================================================================================================
end.
