{=======================================================================================================================

  Comming BASE

     .

========================================================================================================================

  :

  10.05.2007 [+]   AfterClose.
  24.01.2004 [*]   .
  10.12.2003 [-]  uses (Icarus).
  16.07.2003 [-]  uses.
  12.07.2003 [*]  Hint.
  06.04.2003 [*]    Tahoma.
  20.02.2003 [*]   .
  22.01.2003 [*]   TFrame.
  21.01.2003 [*]    .
  07.12.2002 [+]      .
  02.12.2002 [*]   Toolbar2000.
  23.08.2002 [*]    TcoButton.
  05.08.2002 [-]  TAB.
             [-]   Comming BASE.
  04.12.2001 [*]    .
  01.12.2001 [+]  Hint.
  01.11.2001 [*]    akTop.
  05.06.2001 [*]  .
  06.04.1999 [!]   BASE.

========================================================================================================================
  Copyright 19992007 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: BASEfrRoot.pas,v 1.13 2012/10/22 07:05:36 tsk Exp $
=======================================================================================================================}
unit BASEfrRoot;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls, ExtCtrls, ComCtrls,
      // BASE
      BASEfmRoot,
      // Comming:
      CommingButton;

type

  TAfterClose = procedure of object;

  TBASERootFR = class( TFrame )
    btCancel: TcoButton;
    blButton: TBevel;
    procedure btCancelClick( Sender: TObject );
  private   { Private declarations }
    FParentControls: TList;
    FParentActive: TWinControl;
  public      { Public declarations }
    Indent: Integer;
    AfterClose: TAfterClose;
    constructor Create( AOwner: TComponent ); override;
    constructor CreateComming( AOwner: TComponent; APoc: TAfterClose );
    destructor  Destroy; override;
    procedure   ShowModal;
    procedure   CloseModal;
  end;

implementation

{$R *.DFM}
//======================================================================================================================
{ TBASERootFR }
//======================================================================================================================
constructor TBASERootFR.Create( AOwner: TComponent );
begin
  inherited Create( AOwner );
  Name            := ClassName + IntToStr(Handle);
  Parent          := TWinControl( AOwner );
  Indent          := TBASERootFM( AOwner ).dcMain.Height;
  BevelKind       := bkSoft;
  BevelInner      := bvNone;
  BevelOuter      := bvRaised;
  FParentControls := TList.Create;
end;
//======================================================================================================================
constructor TBASERootFR.CreateComming(AOwner: TComponent; APoc: TAfterClose);
begin
  inherited Create( AOwner );
  Name            := ClassName + IntToStr(Handle);
  Parent          := TWinControl( AOwner );
  Indent          := TBASERootFM( AOwner ).dcMain.Height;
  BevelKind       := bkSoft;
  BevelInner      := bvNone;
  BevelOuter      := bvRaised;
  FParentControls := TList.Create;
  AfterClose      := APoc;
end;
//======================================================================================================================
destructor TBASERootFR.Destroy;
begin
  FParentControls.Free;
  inherited Destroy;
end;
//======================================================================================================================
procedure TBASERootFR.ShowModal;
  var i: Integer;
begin
  Parent.Constraints.MinHeight := Height + Parent.Height - Parent.ClientHeight + 5 + Top;
  Parent.Constraints.MinWidth  := Width + Parent.Width - Parent.ClientWidth + 10;
  if akRight in Anchors   then Left := Parent.ClientWidth - Width - 5;
  if akBottom in Anchors  then Top  := Parent.ClientHeight - Height - 5;
  if akLeft in Anchors    then begin
    Left := 5;
    if akRight in Anchors then Width := Parent.ClientWidth - 10;
  end;
  if akTop in Anchors     then Top  := 5 + Indent;
  FParentActive := TForm( Parent ).ActiveControl;
  FParentControls.Clear;
  for i := 0 to Parent.ControlCount - 1 do begin
    if ( Parent.Controls[i].Enabled ) and ( Parent.Controls[i].Visible )
        and ( Parent.Controls[i] <> Self ) then begin
      FParentControls.Add( Parent.Controls[ i ] );
      Parent.Controls[ i ].Enabled := False;
    end;
  end;
  Show;
  BringToFront;
end;
//======================================================================================================================
procedure TBASERootFR.CloseModal;
  var i: Integer;
begin
  for i := 0 to FParentControls.Count - 1 do begin
    TControl( FParentControls[i] ).Enabled := True;
  end;
  Hide;
  Application.ProcessMessages;
  if Assigned( AfterClose ) then AfterClose;
  try
    TForm( Parent ).ActiveControl := FParentActive;
  except end;
end;
//======================================================================================================================
procedure TBASERootFR.btCancelClick(Sender: TObject);
begin
  CloseModal;
end;
//======================================================================================================================
end.
