{===================================================================================================

  Comming BASE

       .

====================================================================================================

  :

  17.09.2008 [+] .
  19.08.2003 [-]   .
  18.07.2003 [+]      .
  19.09.2002 [+]  .
  06.04.1999 [!]   BASE.

====================================================================================================
  Copyright 19992008 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: BASEqrInternal.pas,v 1.8 2008/09/23 06:15:40 tsk Exp $
===================================================================================================}
unit BASEqrInternal;

interface

uses  Windows, Messages, SysUtils, BASEqrRoot, DB, ADODB, Qrctrls, QuickRpt, Forms,
      Classes, Controls, ExtCtrls, PropStorageEh, Menus, PropFilerEh;

type
  TBASEInternalQR = class( TBASERootQR )
    bnPageHeader: TQRBand;
    laPage: TQRSysData;
    laHeadTitle: TQRSysData;
    bnTitle: TQRBand;
    laTitle: TQRSysData;
    bnColumnHeader: TQRBand;
    bnDetail: TQRBand;
    bnSummary: TQRBand;
    bnUser: TQRChildBand;
    laUser: TQRLabel;
    taUser: TADODataSet;
    taUserUserName: TStringField;
    taUserCurrDateTime: TDateTimeField;
    taData: TADODataSet;
    taTitle: TADODataSet;
    procedure bnUserBeforePrint(Sender: TQRCustomBand; var PrintBand: Boolean);
  private   { Private declarations }
  public    { Public declarations }
  end;

implementation

{$R *.dfm}
//==================================================================================================
{ TBASEInternalQR }
//==================================================================================================
procedure TBASEInternalQR.bnUserBeforePrint(Sender: TQRCustomBand; var PrintBand: Boolean);
begin
  try
    taUser.Connection := taData.Connection;
    taUser.Parameters[0].Value := Application.Tag;
    taUser.Open;
    laUser.Caption := ' : ' + taUserUserName.Value + ' (' + taUserCurrDateTime.Text + ').';
    taUser.Close;
  except
    PrintBand := False;
  end;
end;
//==================================================================================================
end.
