{===================================================================================================

  Comming BASE

        , , .

====================================================================================================

  :

  10.12.2009 [+] DataSet.
  27.11.2009 [+]  .
  06.04.1999 [!]   BASE.

====================================================================================================
  Copyright 19992009 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: BASEsfBevelDBLookupCombo.pas,v 1.2 2009/12/10 12:39:30 tsk Exp $
===================================================================================================}
unit BASEsfBevelDBLookupCombo;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, Mask, DB,
      DBCtrls,
      // Comming:
      CommingLookupFlat, ExtCtrls, CommingFlat, ADODB, Menus;

type
  TBASEBevelDBLookupComboSF = class(TFrame)
    cbField: TcoDBLookupCombo;
    bvName: TBevel;
    laName: TcoLabel;
    taChoice: TADODataSet;
    dsChoice: TDataSource;
    pmData: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    procedure dsChoiceDataChange(Sender: TObject; Field: TField);
  private   { Private declarations }
    FEnabled:   Boolean;
    FReadOnly:  Boolean;
    procedure   _SetEnabled( const Value: Boolean );
    procedure   _SetReadOnly(const Value: Boolean);
  public    { Public declarations }
    property    Enabled: Boolean read FEnabled write _SetEnabled;
    property    ReadOnly: Boolean read FReadOnly write _SetReadOnly;
    procedure   Post;
  end;

implementation

{$R *.dfm}
//==================================================================================================
{ TBASEBevelDBLookupComboSF }
//==================================================================================================
procedure TBASEBevelDBLookupComboSF.Post;
begin
  if ( dsChoice.State in [dsEdit, dsInsert]) then taChoice.Post;
end;
//==================================================================================================
procedure TBASEBevelDBLookupComboSF._SetEnabled( const Value: Boolean );
begin
  FEnabled := Value;
  cbField.ReadOnly  := not Value;
end;
//==================================================================================================
procedure TBASEBevelDBLookupComboSF._SetReadOnly( const Value: Boolean );
begin
  FReadOnly         := Value;
  cbField.ReadOnly  := Value;
end;
//==================================================================================================
procedure TBASEBevelDBLookupComboSF.dsChoiceDataChange(Sender: TObject; Field: TField);
begin
  if ( cbField.DataSource.DataSet.Active ) and not ( cbField.DataSource.State in [dsEdit, dsInsert])
    then cbField.DataSource.DataSet.Edit;
end;
//==================================================================================================
end.
