{=======================================================================================================================

  Comming BASE

     . DBEdit  .

========================================================================================================================

  :

  11.05.2013 [*] .
  17.08.2004 [+]  .
  06.04.1999 [!]   BASE.

========================================================================================================================
  Copyright 19992013 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: BASEsfDBEditButton.pas,v 1.4 2013/08/14 05:51:44 tsk Exp $
=======================================================================================================================}
unit BASEsfDBEditButton;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, Mask, DB, DBCtrls,
      // Comming:
      CommingFlat, CommingButton;

type
  TBASEDBEditButtonSF = class(TFrame)
    btLabel: TcoButton;
    edField: TcoDBEdit;
  private   { Private declarations }
    FEnabled:   Boolean;
    FReadOnly:  Boolean;
    procedure   _SetEnabled( const Value: Boolean );
    procedure   _SetReadOnly(const Value: Boolean);
  public    { Public declarations }
    property    Enabled: Boolean read FEnabled write _SetEnabled;
    property    ReadOnly: Boolean read FReadOnly write _SetReadOnly;
  end;

implementation

{$R *.dfm}
//======================================================================================================================
{ TBASEDBEditButtonSF }
//======================================================================================================================
procedure TBASEDBEditButtonSF._SetEnabled( const Value: Boolean );
begin
  FEnabled := Value;
  btLabel.Enabled   := Value;
  edField.ReadOnly  := not Value;
end;
//======================================================================================================================
procedure TBASEDBEditButtonSF._SetReadOnly( const Value: Boolean );
begin
  FReadOnly         := Value;
  edField.ReadOnly  := Value;
  btLabel.NoClick   := Value
end;
//======================================================================================================================
end.
