{==================================================================================================

  Comming BASE

     . DBEdit,        MRU-.

===================================================================================================

  :

  10.07.2003 TSK    Read Only.
  31.03.2003 TSK   .
  06.04.1999 TSK    BASE.

===================================================================================================
  Copyright 1999-2003 TSK Developer Laboratory, Moscow.               Konstantin Tsvetkov
                                                                        e-mail: tsklab@mail.ru
==================================================================================================}
unit BASEsfDBEditCode;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
      Mask, DBCtrls,
      // Comming:
      CommingFlat, CommingButton;

type
  TBASEDBEditCodeSF = class( TFrame )
    laField: TcoLabel;
    edField: TcoDBEdit;
    btMRU: TcoButton;
    btLabel: TcoButton;
    edCode: TcoDBEdit;
  private   { Private declarations }
    FEnabled: Boolean;
    FReadOnly: Boolean;
    procedure   _SetEnabled(const Value: Boolean);
    procedure   _SetReadOnly(const Value: Boolean);
  public    { Public declarations }
    property    Enabled: Boolean read FEnabled write _SetEnabled;
    property    ReadOnly: Boolean read FReadOnly write _SetReadOnly;
  end;

implementation

{$R *.DFM}

//==================================================================================================
{ TBASEDBEditCodeSF }
//==================================================================================================
procedure TBASEDBEditCodeSF._SetEnabled(const Value: Boolean);
begin
  FEnabled          := Value;
  laField.Enabled   := Value;
  edField.Enabled   := Value;
  edField.ReadOnly  := not Value;
end;
//==================================================================================================
procedure TBASEDBEditCodeSF._SetReadOnly(const Value: Boolean);
begin
  FReadOnly         := Value;
  edField.ReadOnly  := Value;
  edCode.ReadOnly   := Value;
  btLabel.Enabled   := not Value;
  btMRU.Enabled     := not Value;
end;
//==================================================================================================
end.
