{===================================================================================================

  Comming BASE

     ,  .

====================================================================================================

  :

  23.06.2005 [+] OnExcelQuery:  Excel  .
             [*]   IsExcel,   .
  29.07.2004 [+]  constructor.
  27.03.2003 [*]  TcoMemoryData  TcoPTable.
  07.12.2001 [+]  .
  06.04.1999 [!]   BASE.

====================================================================================================
  Copyright 19992005 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: BASEfrReportChoice.pas,v 1.5 2008/05/28 12:08:25 tsk Exp $
===================================================================================================}
unit BASEfrReportChoice;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, DB, ExtCtrls,
      // BASE
      BASEfmReport, BASEfrQuery,
      // Comming:
      CommingButton, CommingParameterTable;

type

  TExcelQuery = procedure of object;

  TBASEReportChoiceFR = class( TBASEQueryFR )
    btExcel: TcoButton;
    procedure btExcelClick(Sender: TObject);
  private   { Private declarations }
    FOnExcelQuery: TExcelQuery;
    procedure   SetOnExcelQuery(const Value: TExcelQuery);
  public    { Public declarations }
    constructor Create( AOwner: TComponent ); override;
    constructor CreateComming( AOwner: TComponent; OnStay: TStayQuery; OnExcel: TExcelQuery = nil );
    property    OnExcelQuery: TExcelQuery read FOnExcelQuery write SetOnExcelQuery;
  end;

implementation

uses BASEfrRoot;

{$R *.dfm}
//==================================================================================================
{ TBASEReportChoiceFR }
//==================================================================================================
constructor TBASEReportChoiceFR.Create(AOwner: TComponent);
begin
  inherited Create( AOwner );
  Indent   := TBASEReportFM( AOwner ).frReport.dcFrame.Height;
end;
//==================================================================================================
constructor TBASEReportChoiceFR.CreateComming(AOwner: TComponent;
                                              OnStay: TStayQuery; OnExcel: TExcelQuery);
begin
  inherited Create( AOwner );
  Indent        := TBASEReportFM( AOwner ).frReport.dcFrame.Height;
  OnStayQuery   := OnStay;
  OnExcelQuery  := OnExcel;
end;
//==================================================================================================
procedure TBASEReportChoiceFR.SetOnExcelQuery(const Value: TExcelQuery);
begin
  FOnExcelQuery := Value;
  btExcel.Visible := Assigned( FOnExcelQuery )
end;
//==================================================================================================
procedure TBASEReportChoiceFR.btExcelClick(Sender: TObject);
begin
  if ( taQuery.State in [ dsInsert, dsEdit ] ) then taQuery.Post;
  taQuery.SaveRecordToRegistry;
  if Assigned( FOnExcelQuery ) then FOnExcelQuery;
  CloseModal;
end;
//==================================================================================================
end.
