/*=================================================================================================

   "Videoteq".

        .

===================================================================================================

  :

  28.02.2005 TSK  [*] InsertDataBaseInstant:    (10 ).
  24.02.2005 TSK  [+]  .
  17.12.2004 TSK  [!]  .

===================================================================================================
  Copyright 20042005 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: scDataBaseInstant.sql,v 1.2 2006/04/10 04:03:26 tsk Exp $
=================================================================================================*/
USE Videoteq
--
EXECUTE CheckDropProcedure 'InsertDataBaseInstant'
--
GO
--=================================================================================================
CREATE PROCEDURE InsertDataBaseInstant @Oper VARCHAR(100)
AS
  DECLARE @TOP INT, @MAX INT
  SELECT @TOP = COUNT(*), @MAX = MAX(ID) FROM DataBaseInstant
  IF ( @TOP > 10 ) BEGIN
    SET @MAX = @MAX - 10
    DELETE DataBaseInstant WHERE ( ID <= @MAX )
  END
  INSERT DataBaseInstant( Operation ) VALUES ( @Oper )
--
GO
--=================================================================================================
-- :
EXECUTE InsertDataBaseInstant ''
SELECT * FROM DataBaseInstant ORDER BY Instant DESC
