/*=================================================================================================

   "Videoteq".

       .

===================================================================================================

  :

  15.11.2007 [*] MaxMediumGroup:   .
  09.04.2006 [+] ViewMediumUnit:  .
  08.04.2006 [+]  .
  17.12.2004 [!]  .

===================================================================================================
  Copyright 20042007 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: scInfo.sql,v 1.3 2007/11/15 13:12:25 tsk Exp $
=================================================================================================*/
USE Videoteq
--
EXECUTE CheckDropView      'MaxMediumGroup'
EXECUTE CheckDropView      'ViewMediumUnit'
EXECUTE CheckDropProcedure 'FirstEmptyID'
--
GO
--=================================================================================================
CREATE VIEW MaxMediumGroup
AS
  SELECT LEFT(Number, 2) AS [Group], 
         MAX(LEFT(Number, 80)) AS MaxNumber
    FROM Medium
    GROUP BY LEFT(Number, 2)
--
GO
--=================================================================================================
--CREATE VIEW ViewMediumUnit
--AS
--  SELECT Medium.Number, 
--         MediumKind.Name AS Kind, 
--         Codec.Name AS Codec, 
--         Place.Display AS Place, 
--         Film.Display AS Film
--    FROM Medium 
--      INNER JOIN Place ON Medium.Place = Place.ID
--      INNER JOIN MediumKind ON Medium.Kind = MediumKind.ID 
--      INNER JOIN MediumUnit ON Medium.ID = MediumUnit.Medium
--      INNER JOIN Unit ON MediumUnit.Unit = Unit.ID
--      INNER JOIN Codec ON Unit.Codec = Codec.ID
--      INNER JOIN Film ON Unit.Film = Film.ID
----
--GO
--=================================================================================================
CREATE PROCEDURE FirstEmptyID
AS
  -- 
  DECLARE @FID INT, @FMAX INT
  SET @FID = 1
  WHILE ( EXISTS (SELECT ID FROM Film WHERE (ID = @FID))) SET @FID = @FID + 1
  SELECT @FMAX = MAX( ID ) FROM Film
  --
  SELECT ID as MaxID, [Group], Display, @FID AS EmptyID
    FROM Film
    WHERE (ID = @FMAX)
--
GO
--=================================================================================================
--  DVD-Video, :
--SELECT * FROM ViewMediumUnit
--  WHERE LEFT(Number,1) = 'V' AND Codec = 'Mpeg2 DVD' AND Kind = 'DVD'
--  ORDER BY 1
--  DVD-Video (), :
--SELECT * FROM ViewMediumUnit
--  WHERE LEFT(Number,1) = 'V' AND Codec = 'Mpeg2 DVD' AND Kind = 'DVDR' AND Number > 'V107'
--  ORDER BY 1
--=================================================================================================
-- :
-- SELECT * FROM MaxMediumGroup ORDER BY 1
-- SELECT * FROM ViewMediumUnit ORDER BY 1
EXECUTE FirstEmptyID
