{=======================================================================================================================

   "Videoteq".

    , , ,   Internet, .

========================================================================================================================

  :

  06.10.2013 [-]  .
  26.10.2012 [+]    IE.
  25.10.2012 [+] '', '', '', '', '', '', ''.
             [+]   .
  24.10.2012 [+] '', '', ''.
  23.10.2012 [+]  .
  17.12.2004 [!]  .

========================================================================================================================
  Copyright 20042013 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: frAttributetSearchWeb.pas,v 1.5 2013/10/07 07:25:31 tsk Exp $
=======================================================================================================================}
unit frAttributetSearchWeb;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, OleCtrls,
      SHDocVw, DB, ADODB,
      // BASE:
      BASEfrRoot, BASEfrSearchWeb,
      // Comming:
      CommingButton, CommingFlat, CommingADO, CommingString, CommingLog, CommingSystem,
      // Videoteq:
      frAttributeEdit;

type
  TFilmAttributetSearchWebFR = class(TBASESearchWebFR)
    taFilm: TADODataSet;
    taFilmID: TAutoIncField;
    taFilmDisplayName: TStringField;
    taParam: TADODataSet;
    taParamID: TSmallintField;
    taParamName: TStringField;
    taParamNameMany: TStringField;
    taParamDisplayMany: TStringField;
    btDelete: TcoButton;
    procedure btViewClick(Sender: TObject);
    procedure pnViewResize(Sender: TObject);
    procedure btValueClick(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
  private   { Private declarations }
    FAtt: TFilmAttributeEditFR;
    procedure AfterInsert( Key: Variant );
    procedure ViewStudio;
  public    { Public declarations }
    procedure CheckRun( var AFrame: TFilmAttributetSearchWebFR; AOwner: TComponent; PAClose: TAfterClose; Film: Integer );
  end;

implementation

uses dmCommingData;

{$R *.dfm}
//======================================================================================================================
{ TFilmAttributetSearchWebFR }
//======================================================================================================================
procedure TFilmAttributetSearchWebFR.CheckRun(var AFrame: TFilmAttributetSearchWebFR; AOwner: TComponent;
                                                                                   PAClose: TAfterClose; Film: Integer);
  const URLSearch = 'http://www.kinopoisk.ru/index.php?first=no&kp_query=';
begin
  Screen.Cursor := crHourGlass;
  if AFrame = nil then begin
    AFrame := TFilmAttributetSearchWebFR.Create( AOwner );
    AFrame.AfterClose := PAClose;
  end;
  with AFrame do begin
    RequeryParameters( taFilm, [ Film ]);
    ShowModal;
    OpenSearch( URLSearch, taFilmDisplayName.Value );
  end;
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TFilmAttributetSearchWebFR.pnViewResize(Sender: TObject);
begin
  mmParam.Width := pnRequest.Width div 4;
end;
//======================================================================================================================
procedure TFilmAttributetSearchWebFR.btViewClick( Sender: TObject );
  var Vl: String;
      b: Integer;
//      XP: Boolean;
begin
  inherited;
  mmValue.Clear;
  mmParam.Clear;
//  XP := not IsVista;
  if Pos( 'studio', webSearch.OleObject.Document.URL ) > 0 then begin
    ViewStudio;
    Exit;
  end;
  // :
  RequeryParameters( taParam, [ '' ]);
  Vl := GetValue( '<td itemprop="genre">', '</td>' );
  b := Pos( ', ...', Vl );
  if b > 0 then Vl := Copy( Vl, 1, b - 1 );
  mmParam.Lines.Add( taParamName.Value );
  mmValue.Lines.Add( Vl );
  // :
  RequeryParameters( taParam, [ '' ]);
  Vl := GetValue( '></TD>', '</DIV>' );
  mmParam.Lines.Add( taParamName.Value );
  mmValue.Lines.Add( Vl );
  // :
  RequeryParameters( taParam, [ '' ]);
  Vl := GetValue( '<td itemprop="producer">', '</td>' );
  b := Pos( ', ...', Vl );
  if b > 0 then Vl := Copy( Vl, 1, b - 1 );
  mmParam.Lines.Add( taParamName.Value );
  mmValue.Lines.Add( Vl );
  // :
  RequeryParameters( taParam, [ '' ]);
  Vl := GetValue( '<td itemprop="director">', '</td>' );
  b := Pos( ', ...', Vl );
  if b > 0 then Vl := Copy( Vl, 1, b - 1 );
  mmParam.Lines.Add( taParamName.Value );
  mmValue.Lines.Add( Vl );
  // :
  RequeryParameters( taParam, [ '' ]);
  Vl := GetValue( '></td>', '</td>' );
  b := Pos( ', ...', Vl );
  if b > 0 then Vl := Copy( Vl, 1, b - 1 );
  mmParam.Lines.Add( taParamName.Value );
  mmValue.Lines.Add( Vl );
  // :
  RequeryParameters( taParam, [ '' ]);
//  if XP then begin
  Vl := GetPart( '<!--   -->', '</div>' );
//  end else begin
//    Vl := GetPart( '<td class="actor_list">', '</div>' );
//  end;
  Vl := HTMLDeleteComments( Vl );
  Vl := GetList( Vl, '<SPAN itemprop="actors">', '</SPAN>');
  mmParam.Lines.Add( taParamName.Value );
  mmValue.Lines.Add( Vl );
  // :
  RequeryParameters( taParam, [ '' ]);
  Vl := GetValue( '></td>', '</td>' );
  b := Pos( ', ...', Vl );
  if b > 0 then Vl := Copy( Vl, 1, b - 1 );
  mmParam.Lines.Add( taParamName.Value );
  mmValue.Lines.Add( Vl );
  // :
  RequeryParameters( taParam, [ '' ]);
  Vl := GetValue( '<td itemprop="musicBy">', '</td>' );
  b := Pos( ', ...', Vl );
  if b > 0 then Vl := Copy( Vl, 1, b - 1 );
  mmParam.Lines.Add( taParamName.Value );
  mmValue.Lines.Add( Vl );
  // :
  RequeryParameters( taParam, [ '' ]);
  Vl := GetValue( '></td>', '</td>' );
  b := Pos( ', ...', Vl );
  if b > 0 then Vl := Copy( Vl, 1, b - 1 );
  mmParam.Lines.Add( taParamName.Value );
  mmValue.Lines.Add( Vl );
end;
//======================================================================================================================
procedure TFilmAttributetSearchWebFR.ViewStudio;
  var Vl: String;
begin
  Vl := GetPart( '<b>:', '</table>' );
  Vl := HTMLDeleteTag( Vl );
  Vl := HTMLReplaceSymbol( Vl );
  VL := DeleteChars( Vl, #10#13#9 );
  mmParam.Lines.Add( '' );
  mmValue.Lines.Add( Vl );
end;
//======================================================================================================================
procedure TFilmAttributetSearchWebFR.btValueClick(Sender: TObject);
begin
  while ( mmValue.Lines[0] = '' ) do begin
    mmValue.Lines.Delete(0);
    mmParam.Lines.Delete(0);
  end;
  RequeryParameters( taParam, [ mmParam.Lines[0] ]);
  FAtt.CheckRun( FAtt, Owner, AfterInsert, INSERT_DATA, taFilmID.Value, taParamID.Value, mmValue.Lines[0] );
end;
//======================================================================================================================
procedure TFilmAttributetSearchWebFR.AfterInsert( Key: Variant );
  var Next: Boolean;
      b: Integer;
begin
  Next := False;
  b := Pos( ',', mmValue.Lines[0] );
  if b > 0 then mmValue.Lines[0] := Trim( Copy ( mmValue.Lines[0], b + 1, MaxInt )) else Next := (Next) OR (True);
  Next := (Next) OR ( b <= 0 );
  Next := (Next) OR ( mmValue.Lines[0] = '' );
  if Next then begin
    mmValue.Lines.Delete(0);
    mmParam.Lines.Delete(0);
  end;
end;
//======================================================================================================================
procedure TFilmAttributetSearchWebFR.btDeleteClick(Sender: TObject);
begin
  mmValue.Lines.Delete(0);
  mmParam.Lines.Delete(0);
end;
//======================================================================================================================
end.
