{===================================================================================================

   "Videoteq".

     , .

====================================================================================================

  :

  19.02.2011 [-] , FCC.
  20.05.2008 [+] FCC.
  03.08.2007 [+] , .
  02.08.2007 [*]  .
  17.03.2005 [+]  .
  17.12.2004 [!]  .

====================================================================================================
  Copyright 20042011 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: fmCodec.pas,v 1.4 2011/02/21 05:44:03 tsk Exp $
===================================================================================================}
unit fmCodec;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, PrnDbgeh,
      DB, ADODB, ActnList, TB2Item, TB2Dock, TB2Toolbar, Grids, DBGridEh, ExtCtrls, DBActns,
      StdCtrls, PropStorageEh, PropFilerEh,
      // Base:
      BASEfmTableEdit, BASEsfDBEdit, BASEsfDBComboBox,
      // Comming:
      CommingDBGridEh, TB2ExtItems;

type
  TCodecFM = class( TBASETableEditFM )
    frName: TBASEDBEditSF;
    taTableID: TAutoIncField;
    taTableName: TStringField;
    frKind: TBASEDBComboBoxSF;
    taTableKind: TStringField;
    taTableNameVariation: TStringField;
    taTableFCC: TStringField;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acBackExecute(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
  end;

  procedure CodecRun;
  procedure CodecQuery( Back: TForm = nil; Data: TField = nil );

var CodecFM: TCodecFM;

implementation

uses BASEfmRoot, dmCommingData;

{$R *.dfm}
//==================================================================================================
procedure CodecRun;
begin
  if CodecFM = nil then begin
    Application.CreateForm( TCodecFM, CodecFM );
  end;
  CodecFM.Show;
end;
//==================================================================================================
procedure CodecQuery(Back: TForm; Data: TField);
begin
  CodecRun;
  CodecFM.SetBackForm( Back, Data );
  if Data <> nil then CodecFM.taTable.Locate( 'ID', Data.Value, [] );
end;
//==================================================================================================
{ TCodecFM }
//==================================================================================================
procedure TCodecFM.FormCreate(Sender: TObject);
begin
  inherited;
  DisableItemSelfRun( dmComming.acCodec );
end;
//==================================================================================================
procedure TCodecFM.FormDestroy(Sender: TObject);
begin
  inherited;
  CodecFM := nil;
end;
//==================================================================================================
procedure TCodecFM.acBackExecute(Sender: TObject);
begin
  SetBackValue( taTableID.Value );
  inherited;
end;
//==================================================================================================
end.
