{=======================================================================================================================

   "Videoteq".

      , .

========================================================================================================================

  :

  11.10.2012 [*]   .
  17.02.2011 [+]  .
  17.12.2004 [!]  .

========================================================================================================================
  Copyright 20042012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: fmCodecDeterminant.pas,v 1.2 2012/10/22 07:08:33 tsk Exp $
=======================================================================================================================}
unit fmCodecDeterminant;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, PrnDbgeh,
      DB, ADODB, ActnList, TB2Item, TB2Dock, TB2Toolbar, Grids, DBGridEh, ExtCtrls, DBActns,
      StdCtrls, PropStorageEh, PropFilerEh, TB2ExtItems,
      // Base:
      BASEfmTableEdit, BASEsfDBEdit, BASEsfDBComboBox,
      // Comming:
      CommingDBGridEh, BASEsfDBLookupCombo;

type
  TCodecDeterminantFM = class( TBASETableEditFM )
    frName: TBASEDBEditSF;
    taTableID: TAutoIncField;
    taTableCodec: TIntegerField;
    taTableDeterminant: TStringField;
    frCodec: TBASEDBLookupComboSF;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acBackExecute(Sender: TObject);
    procedure acDataEditExecute(Sender: TObject);
    procedure frNameedFieldChange(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
  end;

  procedure CodecDeterminant;

var CodecDeterminantFM: TCodecDeterminantFM;

implementation

uses BASEfmRoot, dmCommingData, dmLookupComboData;

{$R *.dfm}
//======================================================================================================================
procedure CodecDeterminant;
begin
  if CodecDeterminantFM = nil then Application.CreateForm( TCodecDeterminantFM, CodecDeterminantFM );
  CodecDeterminantFM.Show;
end;
//======================================================================================================================
{ TCodecDeterminantFM }
//======================================================================================================================
procedure TCodecDeterminantFM.FormCreate(Sender: TObject);
begin
  inherited;
  DisableItemSelfRun( dmComming.acCodecDeterminant );
end;
//======================================================================================================================
procedure TCodecDeterminantFM.FormDestroy(Sender: TObject);
begin
  inherited;
  CodecDeterminantFM := nil;
end;
//======================================================================================================================
procedure TCodecDeterminantFM.acBackExecute(Sender: TObject);
begin
  SetBackValue( taTableID.Value );
  inherited;
end;
//======================================================================================================================
procedure TCodecDeterminantFM.acDataEditExecute(Sender: TObject);
begin
  inherited;
end;
//======================================================================================================================
procedure TCodecDeterminantFM.frNameedFieldChange(Sender: TObject);
begin
  if frName.edField.Text = '' then Exit;
  case frName.edField.Text[1] of
    'A': frCodec.RequeryLookup( dmCombo.dsCodecAudio );
    'V': frCodec.RequeryLookup( dmCombo.dsCodecVideo );
  end;
end;
//======================================================================================================================
end.
