/*=================================================================================================

   "Videoteq".

     , .

===================================================================================================

  :

  02.08.2007 [+]  .
  17.12.2004 [!]  .

===================================================================================================
  Copyright 20042007 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: scFilmKind.sql,v 1.1 2007/08/02 06:54:42 tsk Exp $
=================================================================================================*/
USE Videoteq
--
EXECUTE CheckDropProcedure 'RangeFilmKind'
--
GO
--=================================================================================================
CREATE PROCEDURE RangeFilmKind @ID CHAR(1), @Move INT
AS
  DECLARE @RN INT, @SID CHAR(1) 
  --  :
  SELECT @RN = [Order] FROM FilmKind WHERE (Kind = @ID)
  -- :
  IF @Move < 0 SET @RN = @RN - 3
  IF @Move > 0 SET @RN = @RN + 3
  UPDATE FilmKind SET [Order] = @RN WHERE Kind = @ID
  -- :
  DECLARE RangeSort CURSOR FOR
    SELECT Kind FROM FilmKind ORDER BY [Order]
  OPEN RangeSort
  FETCH NEXT FROM RangeSort INTO @SID
  SET @RN = 0
  WHILE @@FETCH_STATUS = 0 BEGIN
    UPDATE FilmKind SET [Order] = @RN WHERE Kind = @SID
    FETCH NEXT FROM RangeSort INTO @SID
    SET @RN = @RN + 2
  END
  CLOSE RangeSort
  DEALLOCATE RangeSort
--
GO

--=================================================================================================
-- 
EXECUTE RangeFilmKind 'V', -1
