{===================================================================================================

   "Videoteq".

     ( ), , .

====================================================================================================

  :

  14.01.2011 [+]  .
  17.10.2010 [*]  ""     .
  09.10.2009 [*]    ""   .
  08.10.2009 [*]    MediaInfo.dll.
  07.10.2009 [+]  MediaInfo.dll.
  19.08.2008 [*]    .
  01.08.2008 [*]  AVI  ,   .
  06.06.2008 [*]  - -.
  20.05.2008 [*]   -.
  16.05.2008 [+]    -.
  01.09.2007 [+]   .
  20.08.2007 [+]    -  -.
  12.08.2007 [+]  -.
  23.03.2007 [*]     .
  12.01.2007 [+]  .
             [*]    "".
             [*]    "".
  05.05.2005 [+]   "".
             [+]   "".
  13.04.2005 [*]    .
             [+]  -.
  17.03.2005 [+]  -.
             [+]   .
             [*] .
  15.03.2005 [+] .
  14.03.2005 [*]      .
             [+]  .
  17.12.2004 [!]  .

====================================================================================================
  Copyright 20042011 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: frUnitEdit.pas,v 1.24 2011/02/21 05:44:04 tsk Exp $
===================================================================================================}
unit frUnitEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ADODB, ExtCtrls, DB,
      StdCtrls, Mask, DBCtrls, DateUtils, MediaInfoDLL, Menus, StrUtils,
      // BASE:
      BASEfrEdit, BASEsfDBEdit, BASEsfDBLookupCombo, BASEsfDBEditDBEdit, BASEsfBevel,
      BASEsfLabelBevel, BASEsfDBEditComboBox, BASEsfBevelDBLookupCombo,
      // Comming:
      CommingButton, CommingADO, CommingString, CommingFile, CommingOther;

type

  TUnitEditFR = class( TBASEEditFR )
    frResolution: TBASEDBEditSF;
    frPlaytime: TBASEDBEditSF;
    frVideoCodec: TBASEDBLookupComboSF;
    frNote: TBASEDBEditDBEditSF;
    frSize: TBASEDBEditComboBoxSF;
    frVideo: TBASELabelBevelSF;
    frAudioCodec: TBASEDBLookupComboSF;
    frAudioBitrate: TBASEDBEditSF;
    frOther: TBASEBevelSF;
    frVideoBitrate: TBASEDBEditSF;
    btFile: TcoButton;
    taDataID: TAutoIncField;
    taDataFilm: TIntegerField;
    taDataCodecVideo: TSmallintField;
    taDataBitrateVideo: TIntegerField;
    taDataResolution: TStringField;
    taDataCodecAudio: TSmallintField;
    taDataBitrateAudio: TIntegerField;
    taDataSize: TLargeintField;
    taDataPlaytime: TStringField;
    taDataNote: TStringField;
    taDataOrder: TIntegerField;
    taDataFormat: TStringField;
    taDataDistinctMark: TStringField;
    procedure frCodecbtLabelClick(Sender: TObject);
//    procedure frResolutionedFieldChange(Sender: TObject);
    procedure frSizeedFieldChange(Sender: TObject);
    procedure frAudioCodecbtLabelClick(Sender: TObject);
    procedure taDataBeforePost(DataSet: TDataSet);
    procedure btFileClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
  private   { Private declarations }
    FFile: String;
  public    { Public declarations }
    procedure CheckRun( var AFrame: TUnitEditFR; AOwner: TComponent; PAPost: TAfterPostKey;
                        ID: Integer; Film: Integer = -1; VFile: String = '*' );
  end;

implementation

uses dmCommingData, dmLookupComboData, fmCodec, dmFindValue;

{$R *.DFM}
//==================================================================================================
{ TUnitEditFR }
//==================================================================================================
procedure TUnitEditFR.CheckRun( var AFrame: TUnitEditFR; AOwner: TComponent;
                                     PAPost: TAfterPostKey; ID, Film: Integer; VFile: String );
begin
  Screen.Cursor := crHourGlass;
  if AFrame = nil then AFrame := TUnitEditFR.CreateComming( AOwner, PAPost );
  with AFrame do begin
    FFile := VFile;
    RequeryParameters( taData, [ ID ]);
    frVideoCodec.RequeryLookup( dmCombo.dsCodecVideo );
//    RequeryParameters( frSoundChoice.taChoice, [ ID ]);
//    frSoundChoice.cbField.KeyValue := frSoundChoice.taChoice.FieldValues['ID'];
//    frAudioKind.RequeryLookup( dmCombo.dsUnitKind );
    frAudioCodec.RequeryLookup( dmCombo.dsCodecAudio );


    if taData.RecordCount = 0 then begin
      taData.Insert;
      taDataFilm.Value := Film;
    end;
    btFile.Enabled := ( VFile <> '*' );
    ShowModal;
  end;
  Screen.Cursor := crDefault;
end;
//==================================================================================================
procedure TUnitEditFR.frCodecbtLabelClick(Sender: TObject);
begin
  inherited;
  CodecQuery( OwnerForm(Self), taDataCodecVideo );
end;
//==================================================================================================
procedure TUnitEditFR.frSizeedFieldChange(Sender: TObject);
begin
  with frSize.edField do begin
    OnChange := nil;
    Text := DelChar( Text, #32 );
    Text := DelChar( Text, ',' );
  end;
  frSize.edField.OnChange := frSizeedFieldChange;
end;
//==================================================================================================
procedure TUnitEditFR.frAudioCodecbtLabelClick(Sender: TObject);
begin
  inherited;
  CodecQuery( OwnerForm(Self), taDataCodecAudio );
end;
//==================================================================================================
procedure TUnitEditFR.taDataBeforePost(DataSet: TDataSet);
begin
  inherited;
  case frSize.cbField.ItemIndex of
    1: taDataSize.Value := taDataSize.Value * 1024;
    2: taDataSize.Value := taDataSize.Value * 1024 * 1024;
    3: taDataSize.Value := taDataSize.Value * 1024 * 1024 * 1024;
  end;
  frSize.cbField.ItemIndex := 0;
end;
//==================================================================================================
procedure TUnitEditFR.btSaveClick(Sender: TObject);
begin
//  frSoundChoice.Post;
  inherited;
end;
//==================================================================================================
//   MediaInfo.dll
//==================================================================================================
procedure TUnitEditFR.btFileClick( Sender: TObject );
  var Handle: Cardinal;
  function GetMediaInfoStr( Kind: TMIStreamKind; Parameter: PChar ): String;
  begin
    Result := MediaInfoA_Get(Handle, Kind, 0, Parameter, Info_Text, Info_Name);
  end;
  function GetMediaInfoInt( Kind: TMIStreamKind; Parameter: PChar ): Int64;
  begin
    Result := StrToInt64Def( MediaInfoA_Get(Handle, Kind, 0, Parameter, Info_Text, Info_Name), 0);
  end;
  function ResolutionCulc ( WS, HS: String ): String;
    var H, W: Integer;
        D: String;
  begin
    W := StrToIntDef( WS, 0);
    H := StrToIntDef( HS, 0);
    if not (( H = 0 ) or ( W = 0 )) then if ( W / H ) < 14/9 then D := '4:3' else D := '16:9';
    Result := Format( '%dx%d (%s)', [ W, H, D ]);
  end;
begin
  if FFile = '*' then Exit;
  Screen.Cursor := crHourGlass;
  taData.Edit;
  if LibHandle = 0 then MediaInfoDLL_Load( 'MediaInfo.dll' );
  Handle := MediaInfo_New();
  MediaInfo_Option (0, 'Complete', '');
  if MediaInfoA_Open( Handle, PChar(FFile)) = 1 then begin
    // FILE:
    taDataPlaytime.Value      := LeftStr( GetMediaInfoStr( Stream_General, 'Duration/String3' ), 8 );
    taDataFormat.Value        := GetMediaInfoStr( Stream_General, 'Format' );
    frSize.cbField.ItemIndex  := 0;
    taDataSize.Value          := GetMediaInfoInt( Stream_General, 'FileSize' );
    if taDataFormat.Value = 'AVI' then begin
      // VIDEO:
      taDataCodecVideo.Value  := dmFind.FindCodec( ckVideo, GetMediaInfoStr( Stream_Video, 'CodecID' ));
      // AUDIO:
      taDataCodecAudio.Value  := dmFind.FindCodec( ckAudio, GetMediaInfoStr( Stream_Audio, 'CodecID' ));
    end else begin
      // VIDEO:
      taDataCodecVideo.Value  := dmFind.FindCodec( ckVideo, GetMediaInfoStr( Stream_Video, 'Format' ));
      // AUDIO:
      taDataCodecAudio.Value  := dmFind.FindCodec( ckAudio, GetMediaInfoStr( Stream_Audio, 'Format' ));
    end;
    // VIDEO:
    taDataResolution.Value    := ResolutionCulc( GetMediaInfoStr( Stream_Video, 'Width' ),
                                                 GetMediaInfoStr( Stream_Video, 'Height' ));
    taDataBitrateVideo.Value  := Round( GetMediaInfoInt( Stream_Video, 'BitRate' )/ 1000 );
    // AUDIO:
    taDataBitrateAudio.Value  := GetMediaInfoInt( Stream_Audio, 'BitRate' ) div 1000;
  end;
  MediaInfo_Close(Handle);
  taDataDistinctMark.Value := dmComming.DistinctFile( FFile );
  Screen.Cursor := crDefault;
end;
//==================================================================================================
end.
