/*=================================================================================================

   "Videoteq".

    .

===================================================================================================

  :

  17.08.2007 [*]   .
  16.08.2007 [+]  .
  17.12.2004 [!]  .

===================================================================================================
  Copyright 20042007 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: scMedium.sql,v 1.3 2007/08/28 11:58:40 tsk Exp $
=================================================================================================*/
USE Videoteq
--
EXECUTE CheckDropProcedure 'PrintMediumFilm'
--
GO
--=================================================================================================
CREATE PROCEDURE PrintMediumFilm @ID INT, @NM VARCHAR(50)
AS
  SELECT DISTINCT  
         Medium.Number, 
         Film.DisplayName AS FilmTitle, 
         Film.DisplayRange
    FROM Medium 
      INNER JOIN MediumUnit ON Medium.ID = MediumUnit.Medium 
      INNER JOIN Unit ON MediumUnit.Unit = Unit.ID 
      INNER JOIN Film ON Unit.Film = Film.ID
    WHERE (Medium.Place = @ID) AND (Medium.Number >= @NM)
    ORDER BY Medium.Number, Film.DisplayRange
--
GO
--=================================================================================================
-- 
 EXECUTE PrintMediumFilm 31, 'Z010'
