/*=================================================================================================

   "Videoteq".

    . .

===================================================================================================

  :

  07.10.2012 [+] ExecFilmWatch:   .
             [+] GridFilmWatch:    .
             [+]  .
  17.12.2004 [!]  .

===================================================================================================
  Copyright 20042012 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: scWatch.sql,v 1.1 2012/10/22 07:08:35 tsk Exp $
=================================================================================================*/
USE Videoteq
--
EXECUTE CheckDropProcedure 'GridFilmWatch'
EXECUTE CheckDropProcedure 'ExecFilmWatch'
--
GO
--=================================================================================================
CREATE PROCEDURE GridFilmWatch
AS
  SELECT Film.ID, 
         FilmPowerName.NameFullYear AS Name,
         Film.DisplayNote AS Note,
         Film.Cover,
         Film.Icon
    FROM Film INNER JOIN FilmPowerName ON Film.ID = FilmPowerName.ID
    WHERE (NOT (Film.Watch IS NULL))
    ORDER BY Film.DisplayRange
--
GO
--=================================================================================================
CREATE PROCEDURE ExecFilmWatch @FL INT, @WT CHAR(1)
AS
  IF (@WT = '-') UPDATE Film SET Watch = NULL WHERE (ID = @FL )
  IF (@WT = '+') UPDATE Film SET Watch = 1 WHERE (ID = @FL )
--
GO
--=================================================================================================
-- 
--EXECUTE GridFilmWatch
